;=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=;
;=                                                                         =;
;= System16                                                                =;
;=                                                                         =;
;=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=;

;LTH - there has been so much modification on this code that it is becoming
;hard to read thru. I have gone thru, deleted the commented code and put comments
;on things that aren't obvious

[bits 16]
org 100h

System16:
	;; we dont need a jump, because it's embedded into
	;; system16 info block

	; Include the system16 info block
	%define _BEGIN BEGIN    ; give him a hint where to jump
	%include "s16struc.asm"

     ;  ------------------------------------------------------------------------
     ; | MISC VARIABLES
     ;  ------------------------------------------------------------------------
	HEXTAB             DB '0123456789ABCDEF'
;LTH - in the .bss section now
;	BOOTDISK_HEADS     DB 0                         ; Maximum number of heads on the bootdisk
;	BOOTDISK_SECTORS   DB 0                         ; Maximum number of sectors on the bootdisk
;	BOOTDISK_CYLINDERS DW 0                         ; Maximum number of cylinders on the bootdisk
;	READ_CYL           DB 0
;	CMOSDATABLOCK      times 37h DB 0
;	TMPSTACK           times 1024 DB 0


     ;  ------------------------------------------------------------------------
     ; | BOOT MESSAGES
     ;  ------------------------------------------------------------------------
	CREATEPARTLIST     DB 'Creating PartList', 13, 10, 0
	TRANSFEROK         DB 'System16 code active', 13, 10, 0
	READSYSTEM32MSG    DB 'Loading System32', 0
	RETRIEVEBOOTSECT   DB 'Retrieving System Code info', 13, 10, 0
	RETRIEVECMOS       DB 13,10,'Retrieving CMOS data', 13, 10, 0
	PROCESSOROK        DB 'Processor Ok.', 13, 10, 0
	A20ENABLE          DB 'Enabling A20 Gate', 13, 10, 0
	PCIBUSSESFOUND     DB 'PCI Busses found: '
	PCIBUSSESNUMBER    DB 'X',13,10,0
	SWITCH2PMODE       DB 'Switching system to protected mode', 13, 10, 0
	PORTALMSG          DB 'Opened and tested the PM2RM Portal', 13, 10, 0
	SECTORREADFAIL     DB 'Failed to read sector.(RM)', 13, 10, 0
	SECTORWRITEFAIL    DB 'Failed to write sector', 13, 10, 0
	QBOOT_MSG          DB 'Restarting...',13,10,13,10,0
	QBOOT_ERROR        DB 'fd0: Can not retrieve bootsector',13,10
			   DB 'Insert a bootdisk and press a key',13,10,0
	VIRTUALPC_MSG      DB 'Virtual PC enabled', 13, 10, 0

     ;  ------------------------------------------------------------------------
     ; | ERROR MESSAGES
     ;  ------------------------------------------------------------------------
	;LTH - used before DISKCHECKFAILED, BOOTSECTORREADFAIL, and SYSTEM32READFAIL
	GENERICERROR       DB 'ERROR: Failed to re',0

	DISKCHECKFAILED   DB 'trieve info on the bootdisk...[?]', 13, 10,0
	BOOTSECTORREADFAIL DB 'trieve bootsector data.', 13, 10, 0
	SYSTEM32READFAIL   DB 'ad System32 Code to memory.', 13, 10, 0
	ERRORLINE1         DB 'An error has occured that prevents v2os from running.', 13, 10
			   DB '       System Halted.', 13, 10, 0


	%include "gdt.inc"

;LTH - moved to the .bss section
;	RMIDTLIMIT         DW 3FFH              ; REAL MODE IDT LIMIT
;	RMIDTBASE          DD 0                 ; REAL MODE IDT BASE
;	PMIDTSAVE          DW 3FFH
;			   DD 0

;LTH - moved to the .bss section
;	DISKINFOBLOCK      times 8 * 32 DB 0    ; 8 ENTRIES OF 32 BYTES
;	PARTLIST           times 16 * 32  DB 0    ; 16 ENTRIES OF 32 BYTES


;LTH - in the .bss section now
;	BS_HEAD            DB 0                 ; Bootsector CHS (eg. 0:0:1 for floppy)
;	BS_SECTOR          DB 0
;	BS_CYLINDER        DB 0

;LTH - unused
;        SINGLE_DOT         DB '.',0
;        SINGLE_STAR        DB '*',0
;        SINGLE_BANG        DB '!',0

	; Include the new V2oS Font
	%INCLUDE "v2osfont.inc"

	%INCLUDE "video.inc"

;-----------------------------------------------------------------------------
; This is where System16 takes control from the bootsector.
;
; IN: (from bootsector)
;     DL = BOOTDISK
;     BL = BOOTPART
;     CL = Cylinder of bootsector
;     CH = Sector of bootsector
;     DH = Head of bootsector
;-----------------------------------------------------------------------------
BEGIN:
	cli                                             ; Setup segments
	mov  ax,cs
	mov  ss,ax
	mov  ds,ax
	mov sp, TMPSTACK + 512   ; VP

;LTH - have to set the RM and PM IDT entries
	mov AX, 3FFh
 	mov [RMIDTLIMIT], AX
	mov [PMIDTSAVE], AX

;LTH - note, the boot sector was modified so cl/ch was not
;swapped, it allowed 1 mov to be used here and a byte or 2 to be
;saved in the boot sector
	mov  [GetS16IB(BootPart)], bl	;07/07/2000[ML]
	mov  [GetS16IB(BootDisk)], dl           ; Save the data given by the bootsector
	mov  [BS_HEAD], dh

;LTH - 1 move instead of 2, merinita - (no it's a bug)
;LTH - no, it is not. Merinita forgot to modify boot.asm to allow it :P
	mov [BS_SECTOR], cx

	mov  [GetS16IB(VideoPort)], word 3D4h
	mov  [GetS16IB(VideoSegment)],word 0B800h
	mov  [GetS16IB(VideoAddr)],dword 0B8000h

;*** SET FANCY SCREENMODE ***
	mov  ax,1112h                                   ; Set 80x50 mode
	mov  bl,0
	int  10h

	call SETV2PALETTE
;        call REPROGRAMFONT

	mov  ah,3
	mov  bh,0
	int  10h
	or   ch,20h
	mov  ah,1
	int  10h                                        ; HIDE CURSOR..

	mov  ax, 0305h                          ; Set typematic rate delay=250ms repeat=30/sec
	xor  bx,bx
	int  16h

	push es
	mov  ax,0F000h                                  ; Look for the string 'Shamah' at F000h:0110h
	mov  es,ax

	mov bx, 110h
	cmp dword [es:bx], "Sham"               ; VP
	jne NOTAMAC                             ; VP
	cmp word [es:bx +4], "ah"               ; VP
	jne NOTAMAC                             ; VP

	mov  [GetS16IB(PCEmulator)], byte 1

	mov  si, VIRTUALPC_MSG
	call WRITELN
NOTAMAC:
	pop  es

	mov  si, TRANSFEROK
	call WRITELN
		
;-----------------------------------------------------------------------------
; This is a real nasty piece of code...
SYSTEM16INITIALIZE:
	pushad

; new version of VP (use bios)
	mov ax, 40h                             ; VP
	mov es, ax                              ; VP
	movzx ax, [es:75h]                      ; VP
	mov [GetS16IB(NumberOfDrives)], ax       ; VP
	mov al, [es:10h]                        ; VP
	test al, 1                              ; VP
	jz .NoFDs                               ; VP
	shl ax, 2                               ; VP
	and ah, 3                               ; VP
.NoFDs  movzx ax, ah                            ; VP
	mov [GetS16IB(NumberOfFloppies)], ax    ; VP

;--------
	mov  ah,8h                              ; Get info about the bootdisk
	mov  dl,[GetS16IB(BootDisk)]
	int  13h
	jnc  DISKCHECKOK

;LTH - 2 lines added to print the generic line, same on the others below
	mov [DISKCHECKFAILED+50], byte '2'
	mov  si, GENERICERROR
	call WRITELN

	mov  si, DISKCHECKFAILED
	call WRITELN

	jmp short $

DISKCHECKOK:
	mov  [BOOTDISK_HEADS],dh                  ; Save the geometry of the bootdisk
	movzx dx,dl
	mov  [GetS16IB(NumberOfFloppies)],dx                ; Very odd: DL=NUMBER OF DISKS

	mov  al,cl                              ; Get the sector

	and  al,00111111b                       ; Much better, we mask 6 bits, not 5
	mov  [BOOTDISK_SECTORS],al


	shr cl, 5                       ; VP (one bug fix)
	xchg cl, ch                     ; VP
	mov [BOOTDISK_CYLINDERS], cx    ; VP


	mov  si, CREATEPARTLIST
	call WRITELN

	mov  di, PARTLIST                 ; First 2 entries are for FD0
	mov  eax, 00306466h               ;'fd0',0 backwards
	mov  [ds:di], eax
	mov  [ds:di+16], eax

	; DISK INFO SHOULD BE OBTAINED BY 08/13h or 15/13h
	mov  [ds:di+6], byte 0
	xor eax, eax
	mov  [ds:di+7],eax                      ; Sector 0
;	mov  eax,11223344h

;[ML] get floppy size = cylinders*sides*sectors per track
	xor dl,dl
	mov ah, 8
	push di
	int 13h
	pop di
;       CH = cylinders (0-1023) -> CX
;       CL = sectors per track -> BX
;       DH = number of sides
	xor ebx, ebx
	mov bl, cl
	and bl, 111111b
	and cl, 11000000b	;its only for future compatability
	xchg ch,cl
	inc cx
 	movzx eax, cx
 	inc dh
	movzx edx,dh
 	mul edx
; 	xor edx,edx	;Not needed i hope
 	mul ebx
;eax may be 1680h,0b40h,960h,5a0h,200h
	mov  [ds:di+0Bh],eax                    ; Sectoramount
;[ML]end
	add  di,32                              ; Go to the 3th entry

;*** ADD THE DRIVES AND THEIR PARTITIONS
	mov  ax,[GetS16IB(NumberOfDrives)]
	test ax, ax
	je near DISKPARTITIONSDONE

	movzx ecx,ax                            ; ECX IS THE AMOUNT OF PHYSICAL DISKS

DISKLOOP:
	push cx


	push cx
	mov  bx,2050h                           ; Disk buffer area
	mov  es,bx
	xor  bx,bx
	mov  ax, 0201h

	mov  dx,[GetS16IB(NumberOfDrives)]      ; Which drive do we want the MBR of (80h/81h etc)
	sub  dx,cx
	add  dl,80h
	mov  dh,0
	push dx             ;save it to call back
	mov  cx, 0001h
	int  13h                                ; Read a sector
	pop  dx             ;put it back to use
	pop  cx

;        mov  dx,[GetS16IB(NumberOfDrives)]
;        sub  dx,cx
;        add  dl,80h
	mov  dh,dl                              ; Save disknumber


	mov  eax, 64680061h                     ; = dh,0,a.
	add  al,dh
	sub  al,80h
	ror  eax, 16                            ;the above now rotated to be
						;the hda,0 (a modified) backwards
	mov  [ds:di], eax
	mov  [ds:di+16], eax

	mov  [ds:di+6],dh

	xor  eax, eax                           ; Start sector
	mov  [ds:di+7], eax      
		
; And again, we need to get the amount of sectors in a decent way (15/13h),
; or with the 48h/13h - extended int 13h functions

	mov  eax,[es:si+0Ch]                    ; Amount of sectors
;	mov  eax,011223344h                     ; NEED TO FIX THIS   :)
	mov  [ds:di+0Bh],eax

	add  di,32


;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; Get Partition info of this disk

	mov si, 1BEh
	mov cx, 4

PARTITIONDUMPLOOP:
	cmp [es:si+4], byte 0          ; Check the ID, is it empty?
	je SKIPTHISPARTITIONENTRY

	mov  eax, 64680061h
	add  al,dh
	sub  al,80h
	ror  eax, 16
	mov  [ds:di+0], eax
	mov  [ds:di+16], eax

	mov  al, '5'
	sub  al, cl                             ; Partition counter
	xor  ah, ah
	mov  [ds:di+3], ax                      ; Part Number

	mov  [ds:di+6],dh                       ; Disk number
	xor  eax, eax
	mov  [ds:di+7],eax                      ; Sector 0

	mov  eax, [es:si+8]                     ; Start sector
	mov  [ds:di+7], eax
	mov  eax, [es:si+0Ch]                   ; Ammount of sectors
	mov  [ds:di+0Bh],eax

	add  di,32
SKIPTHISPARTITIONENTRY:
	add  si,10h
	dec  cx
	jnz  PARTITIONDUMPLOOP

	pop  cx
	dec  cx
	jnz  near DISKLOOP

	mov  [ds:di], byte 0FFh                 ; TERMINATE THE LIST

	popad

DISKPARTITIONSDONE:

	mov ah,8h                               ; Get info from floppy a:
	mov dl,0
	int 13h
	jnc DISKCHECK1OK

;LTH - 2 lines added to print the generic line, same on the others below
	mov [DISKCHECKFAILED+50], byte '3'
	mov  si, GENERICERROR
	call WRITELN

	mov  si, DISKCHECKFAILED
	call WRITELN

	jmp short $

DISKCHECK1OK:
	mov  si, DISKINFOBLOCK
	mov  [ds:si+0], byte 0                  ; Drive number
	mov  [ds:si+6], byte 0                  ; DiskIndex

	mov  [ds:si+1],bl                       ; DriveType
	mov  ah,cl
	shr  ah,6                               ; Keep hi 2 bits
	mov  al,ch
	mov  [ds:si+2],ax                       ; Cylinders
	mov  [ds:si+4],dh                       ; Heads
	and  cl,1Fh                             ; Keep lower 6 bits
	mov  [ds:si+5],cl                       ; Sectors
	mov  [ds:si+7], byte 0                  ; Reserved (?)
	mov  [ds:si+8],dword 534F4942h          ; 'BIOS'
	mov  [ds:si+12],dword 20202020h         ; '    '
	xor  eax,eax
	mov  [ds:si+16],eax                     ; Serving module
	mov  [ds:si+20],eax                     ; Serving module


	mov  eax, 64660030h                     ;'fd',0,'0'
	add  al, [ds:si]                        ; Add drive number
	ror  eax, 16                            ;now 0,'0df' with the right drive #
	mov  [ds:si+24], eax

	add  si,32

	mov  ah,8                               ; Get info
	mov  dl,80h
	int  13h
	test dl, dl                             ; No fixed disks?
	je   near FIXEDDISKINFOSCANDONE

	movzx cx,dl
	mov  dx,80h                             ; Fixed disk

FIXEDDISKINFOSCAN:
	push dx
	push cx
	push dx

	mov  ah,8h
	int  13h
	jnc  DISKCHECK3OK

;LTH - tell which drive we had a prob with
	mov [DISKCHECKFAILED+50], byte '4'
	mov  si, GENERICERROR
	call WRITELN

	mov  si, DISKCHECKFAILED
	call WRITELN

	jmp short $

DISKCHECK3OK:
	mov  [ds:si+1],bl                       ; Drive Type
	mov  ah,cl
	shr  ah,6                               ; Keep hi 2 bits
	mov  al,ch

	mov  [ds:si+2],ax                       ; Cylinders
	mov  [ds:si+4],dh                       ; Heads
	and  cl,3Fh                             ; Keep lower 6 bits
	mov  [ds:si+5],cl                       ; Sectors

	mov  [ds:si+7], byte 0                  ; Reserved

	mov  [ds:si+8],dword 534F4942h          ; 'BIOS'
	mov  [ds:si+12],dword 20202020h         ; '    '
	xor  eax,eax
	mov  [ds:si+16],eax                     ; Serving Module
	mov  [ds:si+20],eax                     ; Serving Module

	pop  dx


	mov  eax, 64680061h                     ;'dh',0,'a'
	add  al, dl
	sub  al, 80h
	ror  eax, 16                            ;'hda',0 backward with right drive
	mov  [ds:si+24], eax

	mov  [ds:si+0],dl                       ; Disk ID
	mov  [ds:si+6],dl                       ; Disk Index

	add  si,32
	pop  cx
	pop  dx
	inc  dx
	dec  cx
	jnz  FIXEDDISKINFOSCAN

FIXEDDISKINFOSCANDONE:
	mov  [ds:si], byte 0FFh                  ; End of DiskChain

	mov  si, RETRIEVEBOOTSECT
	call WRITELN

;LTH - 1 mov :)
	mov ax, 0201h                           ; READ 1 SECTOR
	mov bx,2050h                            ; DISK BUFFER AREA
	mov es,bx                               ; SEG BUFFER
	xor bx,bx                               ; OFS BUFFER
	mov dl,[GetS16IB(BootDisk)]                         ; 'READ FROM' DISK
	mov dh,[BS_HEAD]
	mov ch,[BS_CYLINDER]
	mov cl,[BS_SECTOR]
	int 13h
	jnc BOOTSECTORREADOK

	mov si, BOOTSECTORREADFAIL
	jmp EXIT_ERROR


BOOTSECTORREADOK:
	mov  ax, [es:40]
	mov  [GetS16IB(System16Sectors)],al                 ; Number of system16sectors
	inc  ah
	mov  [GetS16IB(System32Sectors)],ah                 ; Number of system32sectors+1

	jmp short readit                              ; Nasty fix for the system32-reading

;----------------------------------------------------------------------------
;LTH - slight reorder to help in size :)
;LTH - moved to .bss section
;	CUR_HEAD        db 0
;	CUR_SECTOR      db 0
;	CUR_CYLINDER    db 0

;----------------------------------------------------------------------------
; IN:  CH = cylinder
;      CL = sector (and high cylinder)
;      DH = head
; OUT: CH = New Cylinder
;      CL = New Sector (and new high cylinder
;      DH = New Head

IncreaseCHS:
	mov  cx, [CUR_SECTOR]
	mov  dh,[CUR_HEAD]

	mov  dl, cl                             ; DL contains the high cylinder
	and  cl, 00111111b                      ; Kill the high cylinder stuff
	and  dl, 11000000b                      ; Kill the sector stuff

	inc  cl                                 ; Increase the sector

	cmp  cl, [BOOTDISK_SECTORS]               ; Check Sector
	jbe  SectorStillOK

	mov  cl, 1                              ; Sector=1, increase head (sectors start at 1, not at zero!)
	inc  dh

	cmp  dh, [BOOTDISK_HEADS]
	jbe  HeadStillOK

	mov  dh, 0                              ; Head=0, increase cylinder (heads start at 0)
	inc  ch
	jno  NoCylinderOverFlow

	add  dl, 64                             ; Increase high bits of the cylinder

NoCylinderOverFlow:
HeadStillOK:
SectorStillOK:
	add  cl, dl                             ; Merge the high-cylinder and the sector

	mov  [CUR_SECTOR], cx
	mov  [CUR_HEAD],dh

	ret
;----------------------------------------------------------------------------

readit:
	mov  si, READSYSTEM32MSG
	call WRITELN

	xor  eax,eax                      ; CALCULATE THE LOCATION OF MEMORYSPACE FOR SYSTEM32
	mov  al,[GetS16IB(System16Sectors)]
;LTH - EndSystem16Offset is +1 so inc not needed
;	inc  al
        add  al, EndSystem16Offset
	shl  eax,9
	add  eax,400h+100h+512
	;LTH - slight note, there was a shr, shl here. they 0's the bottom 4 bits
	;however the above math doesn't affect those bits and the above shl sets
	;them to 0
	mov  [GetS16IB(System32Addr)],eax
   
	mov  dl,[GetS16IB(BootDisk)]                        ; Reset bootdisk
	mov  ah,0
	int  13h

	;ax = sector and cylinder
	mov  ax, [BS_SECTOR]                       ; Point C:H:S to the bootsector
	mov  [CUR_SECTOR], ax
	mov  al,[BS_HEAD]
	mov  [CUR_HEAD],al

;        xor  ecx,ecx       ; ECX holds the number of sectors we need to skip
;        inc  cx            ; First of all, skip the bootsector, CHS points to the start of system16
	mov  cx, 1h
	add  cl,[GetS16IB(System16Sectors)]                 ; And skip system16.

FindCorrectCHSLoop:                             ; Could be a better way to find the correct CHS, but this is the easiest way
;        push ecx
	push cx
	call IncreaseCHS
;        pop  ecx
	pop cx
	loop FindCorrectCHSLoop

	mov  cl,[GetS16IB(System32Sectors)]                 ; Get the number of sectors to read
;        movzx ecx,cl
	movzx cx,cl
	add  cx,5                              ; AMOUNT OF SECTORS TO READ

	mov  ebx,[GetS16IB(System32Addr)]                   ; To get a segment in bx
	shr  ebx,4                              ; set to segment (/16)
	mov  es,bx
	mov  ebx,100h                           ; Offset to write to


READSYSTEM32TOMEMORY:
;        push ecx
	push cx

	mov  ax,0201h                               ; JUST 1 SECTOR AT A TIME
	mov  dl,[GetS16IB(BootDisk)]
	mov  cx,[CUR_SECTOR]
	mov  dh,[CUR_HEAD]
	int  13h
	jnc  SYSTEM32READOK

	mov  si, SYSTEM32READFAIL
	jmp  EXIT_ERROR

SYSTEM32READOK:        
	push bx
	mov  ax,0e2Eh          ;al = '.'
	xor  bx, bx
	int  10h
	pop  bx

	call IncreaseCHS

;        pop  ecx
	pop cx
	add  bx,512
	dec cx
	jnz  READSYSTEM32TOMEMORY

	mov  si, RETRIEVECMOS
	call WRITELN

	mov  cx,37h
	mov  dl,0
	mov  di, CMOSDATABLOCK

READCMOSLOOP:
	;can't use stosb here, 386/486 only allow double word
	mov  al,dl
	out  70h,al
	in   al,71h
	mov  [ds:di],al
	inc  di
;        stosb
	inc  dl
	loop READCMOSLOOP

	mov  si, PROCESSOROK
	call WRITELN


	mov  ax,0E801h                          ; Get memory
	int  15h
	movzx ebx, bx
	shl  ebx,6
	movzx eax, ax
	add  ebx,eax
	mov  [GetS16IB(ExtMem)],ebx

	call INIT_PCIBUS

	mov  si, A20ENABLE
	call WRITELN

	call ENABLEA20

	mov  si, SWITCH2PMODE
	call WRITELN


   ;---- [ Prepare The System for the BIG-Bang ] ----
   ;*** Set up the descriptor for System16 Code ***
	MOV AX, CS
;the above code blanks out the top part of EAX
;        MOVZX EAX, AX
	SHL EAX, 4
	MOV dword [System16_gdt+2], EAX           ; eax=base for code segment
	MOV byte [System16_gdt+5], 9Ah            ; set segment attribute
	MOV dword [System16Data+2], EAX           ; eax=base for code segment
	MOV byte [System16Data+5], 92h            ; set segment attribute

   ;*** Set up the descriptor for System32 Code ***

	MOV EAX, [GetS16IB(System32Addr)]
	MOV dword [System32_gdt+2], EAX           ; eax=base for code segment
	MOV byte [System32_gdt+5],9Ah             ; set segment attribute

	MOV dword [System32Data+2], EAX           ; eax=base for code segment
	MOV byte [System32Data+5],92H             ; set segment attribute
 

	;*** Prepare the LGDT Instruction ***
	MOV DX, MYGDT
	MOVZX EDX, DX
	MOV AX, CS
	MOVZX EAX, AX
	SHL EAX, 4
	ADD EAX, EDX                            ; eax=base for GDT
	PUSH EAX
	MOV BX, [GetS16IB(GDTEntries)]
	SHL BX, 3                               ; MULIPLY BY 8
	PUSH BX    ; 28H + 8
	MOVZX EAX, SP
	CLI

	; *** Here it goes... ***
	LGDT [SS:EAX]
	ADD SP, 6                               ; Release the stack space used

	MOV word [RM2PM_OFFSET], PM16
	MOV word [RM2PM_DESC], GDT_S16

	JMP RM2PM                               ; BYE BYE REALMODE !


;-----------------------------------------------------------------------------
; This is the PM16 Label.
; From here the system is running in protected mode!!!
; This Code-Descriptor is ofcourse defined as 16Bit,
; But, a few lines ago, the System32 Code got loaded to memory,
; and a Descriptor has been build for it.
; So to run in full-raw-32Bit-protected mode, only one far jmp is required.
; But first the PM2RM Portal needs to be tested. That will jump to System32.
;-----------------------------------------------------------------------------
PM16:
	MOV DX, GDT_BIG                         ; load long segment descriptor from GDT into DS
	MOV DS, DX
	MOV DX, GDT_S16DATA
	MOV SS, DX
	MOV ESP, TMPSTACK + 512
;        ADD ESP, 512

	MOV AX, GDT_S16DATA
	MOV FS, AX
	MOV ES, AX

;;; wanna sleep now, but here GetS16IB() macro seems being nonworking
;;; ******
	
	MOV [FS:GetS16IB(RealEAX)], EAX

;*** PASS CONTROL TO SYSTEM32 ***
	DB 0EAH                                 ; far jump to set CS & clear prefetch queue
	DW 100H
	DW GDT_S32

;-----------------------------------------------------------------------------
; Jump from RealMode to ProtectedMode
;-----------------------------------------------------------------------------
RM2PM:
	; IDT SOMEWHERE ?!?

	mov  eax,cr0
	or   al,1
	mov  cr0,eax                            ; System is now in 'Unreal-Mode'

						;*** Make the major leap out of the Real-mode ***
	db 0EAh                                 ; far jump to set CS & clear prefetch queue
	RM2PM_OFFSET dw 0
	RM2PM_DESC dw 0
; The End

;-----------------------------------------------------------------------------
; Displays a WORD
; IN:  AX=word to write to screen
;      DI=position?
;-----------------------------------------------------------------------------
DISPWORD:
	pushad
	push es

	shl  di,1
	mov  bx, [GetS16IB(VideoSegment)]
	mov  es,ax
	add  di,6
	mov  cx,4
DISPWORDLOOP:
	mov  bx,ax
	and  bx,00001111b
	mov  bl, [ds:HEXTAB+bx]
	mov  [es:di],bl
;        mov  bl,1Fh
	mov  [es:di+1], byte 1Fh
	shr  ax,4
	sub  di,2
	loop DISPWORDLOOP

	pop  es
	popad
	ret

;-----------------------------------------------------------------------------
; Pass DS:SI as a pointer to a zero-terminated textline.
;
; IN: DS:SI = offset to zero-terminated stirng
;-----------------------------------------------------------------------------
WRITELN:
	;this was storing the flags, however i see no reason for this
	pushad

	mov  ah, 0Eh                                    ; BIOS print it
	mov  bx, 0005h
	jmp short STARTWRITELN

NEXTLETTER2:
	int 10h
STARTWRITELN:
	lodsb
	test al, al
	jnz NEXTLETTER2

OUTWRITELOOP2:
	popad
	ret

;-----------------------------------------------------------------------------
; Politely tell the user their system sucks...
;
; IN: DS:SI = offset your_system_suck_message
;-----------------------------------------------------------------------------
EXIT_ERROR:
	push si                                         ; Save the error-stringpointer

	mov  si, ERRORLINE1
	call WRITELN

	mov  si, GENERICERROR
	call WRITELN
	pop  si
	call WRITELN                                    ; ERROR MESSAGE

	JMP short $                                     ; Deadlock yar system

;-----------------------------------------------------------------------------
; Enables the A20 Gate to access the memory over 1MB
;-----------------------------------------------------------------------------
ENABLEA20:                                              ; ENABLE THE A20 GATE
; Code replacement by EKS!!
;--------------------------------

	; Activate old AT A20
	;--------------------
	mov al, 0xD1
	out 0x64, al
	mov al, 0xDF
	out 0x60, al

	; Activate new ps/2 A20
	;----------------------
	mov al, 0x02
	out 0x92, al

	retn

; OLD CODE...
;------------
;	call ENABLEA20O1
;	jnz  short ENABLEA20DONE
;
;	mov  al,0D1h
;	out  64h,al
;	call ENABLEA20O1
;	jnz  short ENABLEA20DONE
;
;	mov  al,0DFh
;	out  60h,al
;
;ENABLEA20O1:
;	xor ecx, ecx
;	inc cx
;	shl ecx, 16
;	mov  ecx,20000h
;ENABLEA20O1L:
;	jmp short $+2                                   ;HUH!?
;	in   al,64h
;	test al,2
;	loopnz ENABLEA20O1L
;ENABLEA20DONE:
;	ret

;-----------------------------------------------------------------------------
INIT_PCIBUS:
	mov  byte [GetS16IB(PCIOK)],0                            ; Check if we have an PCI-bios installed
	mov  byte [GetS16IB(PCIHiBus)],0
	mov  ax,0B101h
	int  1Ah
	jc   EXIT_PCIBUS

	cmp  edx,020494350h                     ; check EDX with ' ICP'
	jne  EXIT_PCIBUS

	mov  [GetS16IB(PCIChar)],al
	inc  cl                                 ; Number of last PCIbus+=1
	mov  [GetS16IB(PCIHiBus)],cl
	xchg bl, bh
	mov  [GetS16IB(PCIVerLo)],BX                        ; Version number is packed in BCD (oh joy)
;        mov  [GetS16IB(PCIVerLo)],BL                        ; Version number is packed in BCD (oh joy)
;        mov  [GetS16IB(PCIVerHi)],BH
	mov  byte [GetS16IB(PCIOK)],1

EXIT_PCIBUS:
	mov  di, PCIBUSSESNUMBER
	mov  al, [GetS16IB(PCIHiBus)]
	mov  [ds:di],al                         ; Make this number a printable one

	mov  si, PCIBUSSESFOUND           ; Show to the user how many we have found
	call WRITELN
	ret


;-----------------------------------------------------------------------------

	; Include the system16 functions and loader
	%include "sysrout/s16funcs.inc"

;END System16

;this is the "global" .bss section, i couldn't manage to define multiple .bss sections
[section .bss]
	BOOTDISK_HEADS     resb 1                       ; Maximum number of heads on the bootdisk
	BOOTDISK_SECTORS   resb 1                       ; Maximum number of sectors on the bootdisk
	BOOTDISK_CYLINDERS resw 1                       ; Maximum number of cylinders on the bootdisk
	READ_CYL           resb 1
	CMOSDATABLOCK      resb 37h
	TMPSTACK           resb 1024
	DISKINFOBLOCK      resb 8 * 32                  ; 8 ENTRIES OF 32 BYTES
	PARTLIST           resb 16 * 32                 ; 16 ENTRIES OF 32 BYTES

	BS_HEAD            resb 1                       ; Bootsector CHS (eg. 0:0:1 for floppy)
	BS_SECTOR          resb 1
	BS_CYLINDER        resb 1

	CUR_HEAD           resb 1
	CUR_SECTOR         resb 1
	CUR_CYLINDER       resb 1

	RMIDTLIMIT         resw 1               ; REAL MODE IDT LIMIT
	RMIDTBASE          resd 1               ; REAL MODE IDT BASE
	PMIDTSAVE          resw 1
			   resd 1

;used in sr03.inc
        SECTORSWRITEN resd 1

;used in sysrout/s16funcs.inc
        SECSINTRAK  resd 1
        HEADSONDISK resw 1

[section .text]
;LTH - I have made a free area after system16. equ is to be that size. Right now
;it is set to all the variables that don't require a exact place in system16.
;i do turn it to sector count so i don't affect some other code

;subtract the last entry in .bss from the top entry in .bss to get the size of it
BssSize equ HEADSONDISK - BOOTDISK_HEADS

;EndSystem16Offset should be a whole number in sectors to hold the data + 1
EndSystem16Offset equ (((512 % BssSize) + BssSize) / 512) + 1
