/* dash_d.c */



#define VERSION "0.005"

#define INFO "Development version, so user beware!\r\nPlease report any bugs to andrews@physics.berea.edu\r\n"



/*

 * 18-DEC-1999 Jesse Andrews <andrews@physics.berea.edu>

 *

 * Version 0.005 (pre pre pre alpha)

 *

 * Project website: http://physics.berea.edu/~andrews/dash.html

 * Latest Source:   http://physics.berea.edu/~andrews/dash-current.c

 * Latest Build:    http://physics.berea.edu/~andrews/dash-current.app

 *

 * For exact GPL license for this code see:

 * http://physics.berea.edu/~andrews/gpl.txt

 *  

 * Copyright under GPL to there respective owner.

 * Base code copyright Jesse Andrews 1999.

 * Any revisions to this code must be published if you distribute your binary.

 * 

 */



#include "v2os.h"



void placechars(char *, char *);

int  dashstrcmp(char *, char *); 

int  add_env(char *, char *);

void echo_env(char *); 

int  compare(char *, char *, int);

int  is_env(char *); 

int  set_env(char *);

int  copy_to_delim(char *, char *, char);  

void clearstr(char *, int);

int  checkcommand(char *, char *, int);

void inputmode(void);

void initmode(void);

void exitmode(void);

void echo_all_env(void);

void puthelp(void);

void puttodo(void);

void concat(char *, char *);



char e1_name[20]=""; char e1_value[40]="";

char e2_name[20]=""; char e2_value[40]="";

char e3_name[20]=""; char e3_value[40]="";

char e4_name[20]=""; char e4_value[40]="";

char e5_name[20]=""; char e5_value[40]="";

char e6_name[20]=""; char e6_value[40]="";

char e7_name[20]=""; char e7_value[40]="";

char e8_name[20]=""; char e8_value[40]="";

char e9_name[20]=""; char e9_value[40]="";

char e10_name[20]=""; char e10_value[40]="";

char e11_name[20]=""; char e11_value[40]="";

char e12_name[20]=""; char e12_value[40]="";

char e13_name[20]=""; char e13_value[40]="";

char e14_name[20]=""; char e14_value[40]="";

char e15_name[20]=""; char e15_value[40]="";

char e16_name[20]=""; char e16_value[40]="";

char e17_name[20]=""; char e17_value[40]="";

char e18_name[20]=""; char e18_value[40]="";

char e19_name[20]=""; char e19_value[40]="";

char e20_name[20]=""; char e20_value[40]="";



char in_func_1[40]="";

char in_func_2[40]="";

char in_func_3[40]="";

char in_func_4[40]="";

char in_func_5[40]="";



// I wish I could use an array.... :(



int e_num=0;



static unsigned char inputted[80]="";

static unsigned char command[80]="";



char *point_a=inputted;

char *point_b=inputted;

char *p1=e1_name; 

char *p2=e1_value;

int valid_command, i, len, success;

unsigned long island, ice, t; // for my boy Curtis hehehe

int t1,t2,t3,t4,t5; 

void main(void)

{

 	initmode();

	inputmode();

	exitmode();

}





int compare(char *pointer_compare_1, char *pointer_compare_2, int len)

{

	int same=1;

	for (i=0; i<len; i++)

	{

		if (*pointer_compare_1!=*pointer_compare_2) same=0;

		pointer_compare_1++; pointer_compare_2++;

	}

	return same;

}



int is_env(char *chk_ptr_1)

{

  int istrue=0;

  

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e1_name)))

    istrue += compare(chk_ptr_1, e1_name, v2_strlen(e1_name)); 

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e2_name)))

    istrue += compare(chk_ptr_1, e2_name, v2_strlen(e2_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e3_name)))

    istrue += compare(chk_ptr_1, e3_name, v2_strlen(e3_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e4_name)))

    istrue += compare(chk_ptr_1, e4_name, v2_strlen(e4_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e5_name)))

    istrue += compare(chk_ptr_1, e5_name, v2_strlen(e5_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e6_name)))

    istrue += compare(chk_ptr_1, e6_name, v2_strlen(e6_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e7_name)))

    istrue += compare(chk_ptr_1, e7_name, v2_strlen(e7_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e8_name)))

    istrue += compare(chk_ptr_1, e8_name, v2_strlen(e8_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e9_name)))

    istrue += compare(chk_ptr_1, e9_name, v2_strlen(e9_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e10_name)))

    istrue += compare(chk_ptr_1, e10_name, v2_strlen(e10_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e11_name)))

    istrue += compare(chk_ptr_1, e11_name, v2_strlen(e11_name)); 

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e12_name)))

    istrue += compare(chk_ptr_1, e12_name, v2_strlen(e12_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e13_name)))

    istrue += compare(chk_ptr_1, e13_name, v2_strlen(e13_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e14_name)))

    istrue += compare(chk_ptr_1, e14_name, v2_strlen(e14_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e15_name)))

    istrue += compare(chk_ptr_1, e15_name, v2_strlen(e15_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e16_name)))

    istrue += compare(chk_ptr_1, e16_name, v2_strlen(e16_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e17_name)))

    istrue += compare(chk_ptr_1, e17_name, v2_strlen(e17_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e18_name)))

    istrue += compare(chk_ptr_1, e18_name, v2_strlen(e18_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e19_name)))

    istrue += compare(chk_ptr_1, e19_name, v2_strlen(e19_name));

  if ((v2_strlen(chk_ptr_1)) == (v2_strlen(e20_name)))

    istrue += compare(chk_ptr_1, e20_name, v2_strlen(e20_name));

  return istrue;

}



int add_env(char *add_ptr_1, char *add_ptr_2)

{

  success = 1;

  if (is_env(add_ptr_1))

  {

    if (dashstrcmp(add_ptr_1, e1_name)) placechars(add_ptr_2, e1_value);

    if (dashstrcmp(add_ptr_1, e2_name)) placechars(add_ptr_2, e2_value);

    if (dashstrcmp(add_ptr_1, e3_name)) placechars(add_ptr_2, e3_value);

    if (dashstrcmp(add_ptr_1, e4_name)) placechars(add_ptr_2, e4_value);

    if (dashstrcmp(add_ptr_1, e5_name)) placechars(add_ptr_2, e5_value);

    if (dashstrcmp(add_ptr_1, e6_name)) placechars(add_ptr_2, e6_value);

    if (dashstrcmp(add_ptr_1, e7_name)) placechars(add_ptr_2, e7_value);

    if (dashstrcmp(add_ptr_1, e8_name)) placechars(add_ptr_2, e8_value);

    if (dashstrcmp(add_ptr_1, e9_name)) placechars(add_ptr_2, e9_value);

    if (dashstrcmp(add_ptr_1, e10_name)) placechars(add_ptr_2, e10_value);

    if (dashstrcmp(add_ptr_1, e11_name)) placechars(add_ptr_2, e11_value);

    if (dashstrcmp(add_ptr_1, e12_name)) placechars(add_ptr_2, e12_value);

    if (dashstrcmp(add_ptr_1, e13_name)) placechars(add_ptr_2, e13_value);

    if (dashstrcmp(add_ptr_1, e14_name)) placechars(add_ptr_2, e14_value);

    if (dashstrcmp(add_ptr_1, e15_name)) placechars(add_ptr_2, e15_value);

    if (dashstrcmp(add_ptr_1, e16_name)) placechars(add_ptr_2, e16_value);

    if (dashstrcmp(add_ptr_1, e17_name)) placechars(add_ptr_2, e17_value);

    if (dashstrcmp(add_ptr_1, e18_name)) placechars(add_ptr_2, e18_value);

    if (dashstrcmp(add_ptr_1, e19_name)) placechars(add_ptr_2, e19_value);

    if (dashstrcmp(add_ptr_1, e20_name)) placechars(add_ptr_2, e20_value);

  }

  if (!is_env(add_ptr_1))

  {

    switch (e_num)

    {

      case (0):  { p1=e1_name;  p2=e1_value;  success=1; break; } 

      case (1):  { p1=e2_name;  p2=e2_value;  success=1; break; }

      case (2):  { p1=e3_name;  p2=e3_value;  success=1; break; }

      case (3):  { p1=e4_name;  p2=e4_value;  success=1; break; }

      case (4):  { p1=e5_name;  p2=e5_value;  success=1; break; }

      case (5):  { p1=e6_name;  p2=e6_value;  success=1; break; } 

      case (6):  { p1=e7_name;  p2=e7_value;  success=1; break; }

      case (7):  { p1=e8_name;  p2=e8_value;  success=1; break; }

      case (8):  { p1=e9_name;  p2=e9_value;  success=1; break; }

      case (9):  { p1=e10_name; p2=e10_value; success=1; break; }

      case (10): { p1=e11_name; p2=e11_value; success=1; break; } 

      case (11): { p1=e12_name; p2=e12_value; success=1; break; }

      case (12): { p1=e13_name; p2=e13_value; success=1; break; }

      case (13): { p1=e14_name; p2=e14_value; success=1; break; }

      case (14): { p1=e15_name; p2=e15_value; success=1; break; }

      case (15): { p1=e16_name; p2=e16_value; success=1; break; } 

      case (16): { p1=e17_name; p2=e17_value; success=1; break; }

      case (17): { p1=e18_name; p2=e18_value; success=1; break; }

      case (18): { p1=e19_name; p2=e19_value; success=1; break; }

      case (19): { p1=e20_name; p2=e20_value; success=1; break; }



      // if all of these fail, we must have no space left :(

      default : { success= 0; }

    }			  

    if (success==1)

    {

      placechars(add_ptr_1, p1);

      placechars(add_ptr_2, p2);

      e_num++; 

    }

  }

  return success;

}



void echo_env(char *echo_ptr)

{

  if (e_num>= 1) if (dashstrcmp(echo_ptr,  e1_name)) puts( e1_value);

  if (e_num>= 2) if (dashstrcmp(echo_ptr,  e2_name)) puts( e2_value);

  if (e_num>= 3) if (dashstrcmp(echo_ptr,  e3_name)) puts( e3_value);

  if (e_num>= 4) if (dashstrcmp(echo_ptr,  e4_name)) puts( e4_value);

  if (e_num>= 5) if (dashstrcmp(echo_ptr,  e5_name)) puts( e5_value);

  if (e_num>= 6) if (dashstrcmp(echo_ptr,  e6_name)) puts( e6_value);

  if (e_num>= 7) if (dashstrcmp(echo_ptr,  e7_name)) puts( e7_value);

  if (e_num>= 8) if (dashstrcmp(echo_ptr,  e8_name)) puts( e8_value);

  if (e_num>= 9) if (dashstrcmp(echo_ptr,  e9_name)) puts( e9_value);

  if (e_num>=10) if (dashstrcmp(echo_ptr, e10_name)) puts(e10_value);

  if (e_num>=11) if (dashstrcmp(echo_ptr, e11_name)) puts(e11_value);

  if (e_num>=12) if (dashstrcmp(echo_ptr, e12_name)) puts(e12_value);

  if (e_num>=13) if (dashstrcmp(echo_ptr, e13_name)) puts(e13_value);

  if (e_num>=14) if (dashstrcmp(echo_ptr, e14_name)) puts(e14_value);

  if (e_num>=15) if (dashstrcmp(echo_ptr, e15_name)) puts(e15_value);

  if (e_num>=16) if (dashstrcmp(echo_ptr, e16_name)) puts(e16_value);

  if (e_num>=17) if (dashstrcmp(echo_ptr, e17_name)) puts(e17_value);

  if (e_num>=18) if (dashstrcmp(echo_ptr, e18_name)) puts(e18_value);

  if (e_num>=19) if (dashstrcmp(echo_ptr, e19_name)) puts(e19_value);

  if (e_num>=20) if (dashstrcmp(echo_ptr, e20_name)) puts(e20_value);

}



// returns true if the same, false if different...

int dashstrcmp(char *s1, char *s2)

{

		int i=0;

		if (!(v2_strlen(s1) == v2_strlen(s2)))

			i++;

		for (; *(s1++) && *(s2++); )

			if (!(*s1 == *s2))

				i++;

		return !i;

}



int set_env(char *set_ptr)

{

  clearstr(in_func_1,35); // this makes sure it is clean 

	 		  // without this line I have problems of

			  // the code "remembering" things that

			  // were previously in in_func_1 

			  // every once in a while 



  t1=copy_to_delim(set_ptr, in_func_1, ' ');

  if (v2_strlen(set_ptr)-t1>0)

    add_env(in_func_1, set_ptr+t1+1); // > 0 because we assume if they

	 			      // didn't enter a value for name

				      // we will not do anything...

  return 1;

}



int copy_to_delim(char *from, char *to, char delim)

{

	int a=0;	

	while (*from != delim && *from != '\0')

	{

		a++;	

		*to=*from;

		to++; from++;

	}

	*to='\0';

	return a;

}	



// This function places the character string that is in s1 into s2

// and terminates it with a \0.   think of it as s2 = s1;

void placechars(char *s1, char *s2)

{

	while (*s1 != '\0')

	{

		*s2=*s1;

		s2++; s1++;

	}

	*s2='\0';

}	



void clearstr(char *str, int count)

{

		while (count>0)

		{

				count--;

				*str='\0';

				str++;

		}

}



int checkcommand(char *typed, char *comm, int method)

{

  if (method==0)  // exactly equal!

  {

    if (v2_strlen(typed)==v2_strlen(comm))

      return (compare(typed,comm,v2_strlen(typed)));

    else

      return 0;

  }

  else if (method==1)  // 2 is started by 1

  {

    if (v2_strlen(typed)<=v2_strlen(comm))

      return (compare(typed,comm,v2_strlen(typed)));

    else

      return 0;

  }

  else if (method==2) // 1 is started by 2

  {	

    if (v2_strlen(typed)>=v2_strlen(comm))

      return (compare(typed,comm,v2_strlen(comm)));

    else

      return 0;

  }

  else return 0;

}



void inputmode(void)

{

  do

  {

    echo_env("prompt");

    gets(inputted);

    len=v2_strlen(inputted);

//    point_a = inputted;  // I don't think this is needed...

    valid_command=1;

    if (len > 0) valid_command=0;



    if (checkcommand(inputted,"ls",0) || 

        checkcommand(inputted,"dir",0) ||

        checkcommand(inputted,"files",0))

    {	shell_command("files"); valid_command=1;  }



    if (checkcommand(inputted,"disklist",0))

    { 	shell_command("disklist"); valid_command=1;  }



    if (checkcommand(inputted,"partlist",0))

    {   shell_command("partlist"); valid_command=1;  }



    if (checkcommand(inputted,"parttable",0) ||

        checkcommand(inputted,"parttables",0))

    {   shell_command("parttable"); valid_command=1;   }



    if (checkcommand(inputted,"gdt",0))

    {   shell_command("gdt");  valid_command=1; }



    if (checkcommand(inputted,"memmap",0))

    {   shell_command("memmap");  valid_command=1;   }



    if (checkcommand(inputted,"memtop",0))

    {   shell_command("memtop");  valid_command=1;   }



    if (checkcommand(inputted,"modlist",0))

    {   shell_command("modlist");  valid_command=1;   }



    if (checkcommand(inputted,"serverlist",0))

    {   shell_command("serverlist"); valid_command=1;   }



    if (checkcommand(inputted,"crash",0))

    {   shell_command("crash");  valid_command=1;  }



    if (checkcommand(inputted,"pciinfo",0))

    {   shell_command("pciinfo");   valid_command=1;  }



    if (checkcommand(inputted,"pic",0))

    {   shell_command("pic"); valid_command=1; }



    if (checkcommand(inputted,"v2help",0))

    {   shell_command("help c");  valid_command=1;  }



    if (checkcommand(inputted,"v2keys",0))

    {   shell_command("help k");  valid_command=1;  }



    if (checkcommand(inputted,"set",0))

    {

	echo_all_env();

	valid_command=1;	

    }	

	   

    if (checkcommand(inputted,"set ",2))

    {

	set_env(inputted+4);  // we add four to get rid of "set "

	valid_command=1;

    }



    if (checkcommand(inputted,"exit",0))

	valid_command=1;  // this is so it doesn't try to run exit.app



    if (checkcommand(inputted,"more ",2) ||

	checkcommand(inputted,"read ",2))

    {

	puts("This is a cheat... Actually running read (v2os command)\r\n\r\n---file---\r\n");

	clearstr(command,40);

	concat("read ", command);

	concat(inputted+5,command);

	shell_command(command);

	puts("---eof---\r\n");

	valid_command=1;

    }



    if (checkcommand(inputted,"copy ",2) ||

	checkcommand(inputted,"cp ",2))

    {

	clearstr(command,40);

	concat("copy ", command);

	if (checkcommand(inputted,"copy ",2))

		concat(inputted+5,command);

	else

		concat(inputted+3,command);

	shell_command(command);

	valid_command=1;

    }



    if (checkcommand(inputted, "fileinfo ",2))

    {

	shell_command(inputted);

	valid_command=1;

    }



    if (checkcommand(inputted, "rm ", 2))

    {

	shell_command(inputted);

	valid_command=1;

    }



    if (checkcommand(inputted, "format ", 2))

    {

	shell_command(inputted);

	valid_command=1;

    }



    if (checkcommand(inputted, "execimg ", 2))

    {

	shell_command(inputted);

	valid_command=1;

    }



    if (checkcommand(inputted, "rs ", 2))

    {

	shell_command(inputted);

	valid_command=1;

    }



    if (checkcommand(inputted, "syscopy ", 2))

    {

	shell_command(inputted);

	valid_command=1;

    }



    if (checkcommand(inputted,"q1",0))

    {   shell_command("q1"); valid_command=1; }

    if (checkcommand(inputted,"q2",0))

    {   shell_command("q2"); valid_command=1; }

    if (checkcommand(inputted,"q3",0))

    {   shell_command("q3"); valid_command=1; }

    if (checkcommand(inputted,"q4",0))

    {   shell_command("q4"); valid_command=1; }

    if (checkcommand(inputted,"q5",0))

    {   shell_command("q5"); valid_command=1; }





    if (checkcommand(inputted,"reboot",0) || 

	checkcommand(inputted,"qboot",0)) 

    {   shell_command("qboot");  valid_command=1;  }  // v_c = 1 not needed :)

  

    if (checkcommand(inputted,"todo", 0))

    {

	puttodo();

	valid_command=1;

    }

    if (checkcommand(inputted,"help",0))

    {

	puthelp();

	valid_command=1;

    }



    if (checkcommand(inputted,"export",0))

    {

	echo_all_env();

        valid_command=1;

    }



   if (!valid_command)

   {

	clearstr(command,40);

	concat("run ", command);

	concat(inputted, command);

	concat(".app", command);

	shell_command(command);

   }

   } while (!checkcommand(inputted,"exit",0));

}



void initmode(void)

{

	add_env("prompt","$ ");

	puts("Welcome to DASH verion ");

	puts(VERSION);

	puts("\r\n");

	puts(INFO);

}



void exitmode(void)

{

	puts("\r\nAnd all I got was this crappy fortune...\r\n");

}	



void echo_all_env(void)

{

      switch (e_num)

      {

        case (20): { puts(e20_name); puts("="); puts(e20_value); puts("\r\n"); }

        case (19): { puts(e19_name); puts("="); puts(e19_value); puts("\r\n"); }

        case (18): { puts(e18_name); puts("="); puts(e18_value); puts("\r\n"); }

        case (17): { puts(e17_name); puts("="); puts(e17_value); puts("\r\n"); }

        case (16): { puts(e16_name); puts("="); puts(e16_value); puts("\r\n"); }

        case (15): { puts(e15_name); puts("="); puts(e15_value); puts("\r\n"); }

        case (14): { puts(e14_name); puts("="); puts(e14_value); puts("\r\n"); }

        case (13): { puts(e13_name); puts("="); puts(e13_value); puts("\r\n"); }

        case (12): { puts(e12_name); puts("="); puts(e12_value); puts("\r\n"); }

        case (11): { puts(e11_name); puts("="); puts(e11_value); puts("\r\n"); }

        case (10): { puts(e10_name); puts("="); puts(e10_value); puts("\r\n"); }

        case  (9): {  puts(e9_name); puts("=");  puts(e9_value); puts("\r\n"); }

        case  (8): {  puts(e8_name); puts("=");  puts(e8_value); puts("\r\n"); }

        case  (7): {  puts(e7_name); puts("=");  puts(e7_value); puts("\r\n"); }

        case  (6): {  puts(e6_name); puts("=");  puts(e6_value); puts("\r\n"); }

        case  (5): {  puts(e5_name); puts("=");  puts(e5_value); puts("\r\n"); }

        case  (4): {  puts(e4_name); puts("=");  puts(e4_value); puts("\r\n"); }

        case  (3): {  puts(e3_name); puts("=");  puts(e3_value); puts("\r\n"); }

        case  (2): {  puts(e2_name); puts("=");  puts(e2_value); puts("\r\n"); }

        case  (1): {  puts(e1_name); puts("=");  puts(e1_value); puts("\r\n"); 

	              break; }

      }

}



void puthelp(void)

{

      puts("\r\n\r\nHELP for the first V2_OS Shell: dash\r\n");

      puts("---------------------------------------------------------\r\n");

      puts("dir, ls         - Lists the files on the floppy drive\r\n");

      puts("exit            - Exits this program\r\n");

      puts("help            - Displays this help file\r\n");

      puts("todo            - Displays the To Do list\r\n");

      puts("reboot          - Restarts V2 OS (Same as F12 key)\r\n");

      puts("set prompt xyz  - change the prompt to xyz\r\n");

      puts("set var value   - set the environmental variable var to value\r\n");

      puts("v2help          - Displays the V2 OS help for commands\r\n");

      puts("                  (most of which can be run from dash)\r\n");

      puts("v2keys          - Displays the V2 OS help for keys\r\n\r\n");

      puts("<anything else> - Tries to execute that string as an .app\r\n");

      puts("---------------------------------------------------------\r\n\r\n");

}



void puttodo(void)

{

      puts("Dash To Do List\r\n");

      puts("---------------------------------------------------------\r\n");

      puts(" Implement environment varible space for dash\r\n");

      puts(" Implement a dashrc which is to run upon entering dash\r\n");

      puts(" Implement all other v2os commands (format, etc)\r\n");

      puts(" ???? Decide if this should be Object Oriented ????\r\n");

      puts(" have a kick but demo like enter scence\r\n");

      puts(" enable up/down to cycling through previous commands\r\n");

      puts(" enable left/right to edit current command\r\n");

      puts(" ... \r\n\r\n");

      puts(" Please, Please, Please send me your wish lists, etc.\r\n\r\n");

      puts(" Jesse Andrews  ---  andrews@physics.berea.edu\r\n");

      puts("---------------------------------------------------------\r\n");

}



void concat(char *source, char *destination)

{

	p1=source;

	p2=destination;

	while (*p2!='\0')

	{

		p2++;

	}

	while (*p1!='\0')

	{

		*p2=*p1;

		p1++; p2++;

	}

	*p2='\0';

}

