/*
 * Fraktal
 * Version 0.0.1
 *
 * Author: Peter Sieg <peter.sieg@gmx.de>
 *
 * License: GPL
 *
 * Download: 
 */

#include "draw.c"
#include "rand.c"

static int xy,x,y,n,a,z;
static short at,at1,ch,hc;

void g(int x, int y)
{
  hc = getxchr(x,y); 
  at = getxcol(x,y);
}

void w(int x, int y)
{
  if (x<2) x = 2; if (y<2) y = 2;
  putcc(x,y,ch,at);
}

void fr(void)
{
  for (x=1;x<40;x++)
    for (y=1;y<24;y++)
      putcc(x,y,' ',0x07); /* clear drawing area */

  ch = 'H'; hc = 'H';
  for (n=1;n<=4;n++) /* set 4 seeds */
  {
    x = r250n(38)+1;
    y = r250n(22)+1;
    at= r250n(14)+1;
    w(x,y);
  }

  for (a=0;a<100;a++)
  {
    for (x=2;x<39;x++)
    {
      /*delay(3);*/
      for (z=0;z<10;z++)
      {
        y = r250n(21)+2;
        g(x,y-1);
        if (ch!=hc) g(x-1,y);
        if (ch!=hc) g(x,y+1);
        if (ch!=hc) g(x+1,y);
        if (ch==hc)
        {
          if (xy==1)  w(x,y);
          if (xy==2) 
          {
            if (at<127) at=at+2;
            w(x,y);
          }
          if (xy==3) 
          {
            at1=at;
            g(x,y);
            at=at1;
            if (ch!=hc)
            {
              if (at<126) at=at+3;
              w(x,y);
            }
          }
        }
      }
    }
  }  
}

int main()
{
  int i, seed = 47;
  // initialize the random number generator with the given seed
  // we need a randomize function to be the seed (ToDo)

Begin:
  seed++;
  r250_init(seed);

  clear(0xbb); // green background
/****/
  for (xy=1;xy<=3;xy++) fr();
/****/
  if (msgboxyesno(23, 35, "   Demo done!! Once again?   ") == 0)
    goto Begin;
  else goto End;

End:
  restoreterm();
  puts("\r\n");
  return 0;
}
