; hello.app
; Hello World example app written for NASM
; hereby placed into the public domain.  do with it what you will

; to assemble type
;  nasm -f bin hello.asm
; then copy the resulting file to your v2_os disk
;  v2copy hello hello.app
; reboot and run as
;  run hello.app

BITS 32         ; set NASM for 32bit output

ORG 0x100       ; program loaded into memory at address 100h?

SECTION .text   ; declare text (code) segment

; code goes here..
; prepare print request
                mov al, 4       ; System32 service number 4 (print text)
                mov edi, hellostr       ; point to the text
; make print request
                int 0x20        ; call System32 to print the text
; message printed, return to system
                retf            ; this returns to System32

SECTION .data   ; declare data segment
hellostr:       db 'Hello, World!',13,10,0  ; the string to print, 0-terminated
