;=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=;
;=                                                                         =;
;= Timer Demo                                                              =;
;=                                                                         =;
;=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=;
.MODEL TINY
.386p


code32  segment para public use32
code32  ends

code32  segment para public use32
        assume cs:code32, ds:code32
        ORG 100H
TimerDemo:
   JMP INITIALIZE
        TIMERDEMOMSG1            DB 'TimerDemo v0.1',13 ,10
                                 DB 'Requires V2_OS V0.53 or higher...',13 ,10, 13,10
                                 DB 'The original timerhandler makes those light blue lines on top',13,10
                                 DB 'of the screen move... So as long as they move the original timer',13 ,10
                                 DB 'handler is being called...',13 ,10
                                 DB '-PRESS A KEY TO CONTINUE-',13 ,10 ,0

        TIMERDEMOMSG2            DB 13,10,'TIMERHANDLER1 is now installed.',13,10
                                 DB 'The blue lines don''t move anymore, instead some letters are being',13 ,10
                                 DB 'printed by the new handler...',13 ,10
                                 DB '-PRESS A KEY TO CONTINUE-',13 ,10 ,0
        TIMERDEMOMSG3            DB 13,10,'TIMERHANDLER2 is now installed.',13,10
                                 DB 'The blue lines now move AND the letters are being',13 ,10
                                 DB 'printed by the new handler...',13 ,10
                                 DB 'The timerhandler2 prints letters, and then jumps to the ',13 ,10
                                 DB 'original timer...',13 ,10
                                 DB '-PRESS A KEY TO CONTINUE-',13 ,10 ,0
        TIMERDEMOMSG4            DB 13,10,'The original timer is set again.',13,10
                                 DB '-end-',13 ,10 ,0


        SAV_TIMERSEL        DW ?
        SAV_TIMEROFS        DD ?
;---------------------------------------------------------------------------
TIMERHANDLER1:
  CLI
  PUSH EAX
    ; SCROLL THROUGH THE LETTERS ON THE SCREEN...
    MOV AL,GS:[0B8002H+(77*2)+(55*160)]
    INC AL
    MOV GS:[0B8002H+(77*2)+(55*160)], AL

    ; MARK IRQ AS 'HANDLED'
    MOV AL, 20H
    OUT 020H, AL
  POP EAX

  STI    ; IRQ'S ON AGAIN
IRETD    ; END OF HANDLER
;---------------------------------------------------------------------------
TIMERHANDLER2:
  CLI
  PUSH EAX
    ; SCROLL THROUGH THE LETTERS ON THE SCREEN...
    MOV AL,GS:[0B8002H+(77*2)+(55*160)]
    INC AL
    MOV GS:[0B8002H+(77*2)+(55*160)], AL
  POP EAX
  STI
  ; AND JUMP TO THE ORIGINAL HANDLER
  DB 0EAH            ; FAR JUMP
  ORGTIMEROFS DD 0   ; THESE 2 VARIABLES ARE BEING SET BELOW...
  ORGTIMERSEL DW 0
IRETD
;---------------------------------------------------------------------------
INITIALIZE:
     MOV AL, 4
     MOV EDI, OFFSET TIMERDEMOMSG1
     INT 20H

     WAITKEY1:
      STI
      MOV AL, 1DH
      INT 20H
      CMP AL, 0
     JE WAITKEY1

     MOV AL, 42                ; GET IRQ VECTOR
     MOV AH, 8                 ; INT 8 = IRQ 0 = TIMER IRQ
     INT 20H

     MOV SAV_TIMERSEL, BX      ; THE SELECTOR/SEGMENT OF THE TIMERHANDLER
     MOV SAV_TIMEROFS, EDI     ; THE OFFSET OF THE TIMERHANDLER

     MOV ORGTIMERSEL, BX       ; TO MAKE THE JUMP IN TIMERHANDLER2 WORK...
     MOV ORGTIMEROFS, EDI



     MOV AL, 1                 ; SET INT VECTOR
     MOV AH, 8
     MOV EDI, OFFSET TIMERHANDLER1
     MOV BX, CS
     INT 20H

     MOV AL, 4
     MOV EDI, OFFSET TIMERDEMOMSG2
     INT 20H

     WAITKEY2:
      STI
      MOV AL, 1DH
      INT 20H
      CMP AL, 0
     JE WAITKEY2


     MOV AL, 1                 ; SET INT VECTOR
     MOV AH, 8
     MOV EDI, OFFSET TIMERHANDLER2
     MOV BX, CS
     INT 20H


     MOV AL, 4
     MOV EDI, OFFSET TIMERDEMOMSG3
     INT 20H

     WAITKEY3:
      STI
      MOV AL, 1DH
      INT 20H
      CMP AL, 0
     JE WAITKEY3



     MOV AL, 1                 ; SET INT VECTOR
     MOV AH, 8
     MOV EDI, SAV_TIMEROFS
     MOV BX, SAV_TIMERSEL
     INT 20H

     MOV AL, 4
     MOV EDI, OFFSET TIMERDEMOMSG4
     INT 20H

     ; CLEAN UP THAT CHAR ON TOP OF THE SCREEN...
     XOR AL, AL
     MOV GS:[0B8002H+(77*2)+(55*160)], AL



  RETF
;

code32  ends

END TimerDemo

