/* mod.lds */

/*
 * 22/12/1999 Joost Faassen, Carlo Prelz
 * Copyright (C) 1999 V2_Lab Rotterdam
 *	
 * The linker script for linking V2_OS modules.
 * It is the result of long and painful efforts. This territory
 * was completely unexplored before, and only a few marking posts are
 * now in place. 
 * The important things is that IT WORKS (or at least it  seems to)
 *
 * $Log: mod.lds,v $
 * Revision 1.1  1999/12/23 10:30:52  karl
 * Initial revision
 *
 */

OUTPUT_FORMAT("binary")
OUTPUT_ARCH(i386)
ENTRY(_start)

SECTIONS
{
  .text1 0x100 :
  {
    modload.o(.text) ;
  }

  .hdr 0x108 :
  {
    *(.hdr) ;
  }

  .bss :
  {
    *(.bss) *(COMMON);
  }

  .text2 :
  {
    *(.text) ;
  }

  .data : 
  {
    *(.data) ;
  }
  .rodata : 
  {
    *(.rodata) ;
  }
  .various :
  {
    *(.note) *(.comment);
  }
}

