/* std.lds */

/*
 * 10/12/1999 Joost Faassen, Carlo Prelz
 * Copyright (C) 1999 V2_Lab Rotterdam
 *	
 * The linker script for linking V2_OS programs.
 * It is the result of long and painful efforts. This territory
 * was completely unexplored before, and only a few marking posts are
 * now in place. 
 * The important things is that IT WORKS (or at least it  seems to)
 *
 * $Log: std.lds,v $
 * Revision 1.1  1999/12/23 10:29:33  karl
 * Initial revision
 *
 */

OUTPUT_FORMAT("binary")
OUTPUT_ARCH(i386)
ENTRY(_start)
FORCE_COMMON_ALLOCATION

SECTIONS
{
  .text1 0x100 :
  {
    loader.o(.text) ;
  }
  .bss :
  {
    *(.bss) *(COMMON);
  }
  .various :
  {
    *(.note) *(.comment);
  }
  .data : 
  {
    *(.data) ;
  }
  .text2 :
  {
    *(.text) ;
  }
  .rodata : 
  {
    *(.rodata) ;
  }
}
