;=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=;
;=                                                                         =;
;= System16                                                                =;
;=                                                                         =;
;=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=;
.MODEL TINY
.CODE
.386p
ORG 100H

System16:
   JMP BEGIN
     ; The world famous System16Infoblock, tada !

     DUMMYBYTE          DB 0    ; OFFSET:
     SYSTEM16SECTORS    DB 0    ; 4
     SYSTEM32SECTORS    DB 0    ; 5
     SYSTEM16ADDR       DD 500H  ; 6
     SYSTEM32ADDR       DD 0    ; 10
     PM2RMPORTAL_SEG    DW 0    ; 14
     PM2RMPORTAL_OFS    DW 0    ; 16
     IDTLENGTH          DW 256*8 ; 18
     IDTADDR            DD 0     ; 20
     GDTLENGTH          DW 0FFFFH ; 24
     GDTADDR            DD 0      ; 26
     STACKADDR          DD 0      ; 30
     STACKSIZE          DD 03000H-1 ; 34
     SYSTEM16FUNCOFS    DW OFFSET SYSTEM16FUNCTION ; 38

     SYSTEM16FUNC_RETURN_ADDR DD 0        ; 40

     REAL_EAX           DD 0  ;44
     REAL_EBX           DD 0  ;48
     REAL_ECX           DD 0  ;52
     REAL_EDX           DD 0  ;56
     REAL_ESI           DD 0  ;60
     REAL_EDI           DD 0  ;64
     REAL_DS            DW 0  ;68
     REAL_ES            DW 0  ;70
     REAL_FS            DW 0  ;72
     KB_AREA            DD 0  ;74
     BOOTUP_GDT         DW OFFSET MYGDT  ;78
     GDT_ENTRIES        DW 6  ;80
     DISKBUFFERSEGMENT  DW 0  ;82
     DISKBUFFERSIZE     DD 0FFFFH ;84
     NUMBEROFDRIVES     DW 0  ;88
     DISKINFO_OFFSET    DW OFFSET DISKINFOBLOCK ; 90
     FILLWORD           DW 0  ; 92
     BOOTDISK           DB 0  ; 94
     CMOSOFFSET         DD OFFSET CMOSDATABLOCK ; 95
     ALLIGNBYTE         DB 0  ; 99
     FOUND_CYLINDER     DD 0  ; 100
     FOUND_HEAD         DD 0  ; 104
     FOUND_SECTOR       DD 0  ; 108
     PARTLIST_OFFSET    DW OFFSET PARTLIST ; 112
     NUMBEROFFLOPPIES   DW 0  ;114
     MODLISTOFFSET      DD 0  ;116
     MODLISTSIZE        DD 0FFFFH ;120
     SERVERLISTOFFSET   DD 0      ;124
     SERVERLISTSIZE     DD 0FFFFH ;128
     COUNTER            DD 0      ;132
     PCIOK              DB 0      ;136
     PCICHAR            DB 0      ;137
     PCIVERHI           DB 0      ;138
     PCIVERLO           DB 0      ;138
     PCI_HIBUS          DB 0      ;139
     TIMERCOUNTER       DB 0      ;140
     CURSORBLINK        DB 0      ;141
     PCEMULATOR         DB 0      ;143
     EXTMEM             DD 0      ;144

     ;  ------------------------------------------------------------------------
     ; | MISC VARIABLES
     ;  ------------------------------------------------------------------------
     HEXTAB             DB '0123456789ABCDEF'
     BOOTDISK_HEADS     DB 0
     BOOTDISK_SECTORS   DB 0
     BOOTDISK_CYLINDERS DW 0
     READ_CYL           DB 0
     CMOSDATABLOCK      DB 37H DUP (?)
     TMPSTACK           DB 1024 DUP (?)
     ;  ------------------------------------------------------------------------
     ; | BOOT MESSAGES
     ;  ------------------------------------------------------------------------
     CR_LF              DB 13, 10, 0
     CREATEPARTLIST     DB 'Creating PartList.', 13, 10, 0
     TRANSFEROK         DB 'System16 code active.', 13, 10, 0
     READSYSTEM32MSG    DB 'Loading System32 to memory.', 0
     RETRIEVEBOOTSECT   DB 'Retrieving System Code info.', 13, 10, 0
     RETRIEVECMOS       DB 'Retrieving CMOS data.', 13, 10, 0
     PROCESSOROK        DB 'Processor Capabilities Check: Ok.', 13, 10, 0
     A20ENABLE          DB 'Enabling A20 Gate', 13, 10, 0
     PCIBUSSESFOUND     DB 'PCI Busses found: '
     PCIBUSSESNUMBER    DB 'X',13,10,0
     SWITCH2PMODE       DB 'Switching system to protected mode...', 13, 10, 0
     PORTALMSG          DB 'Opened and tested the PM2RM Portal...', 13, 10, 0
     SECTORREADFAIL     DB 'Failed to read sector.(RM)', 13, 10, 0
     SECTORWRITEFAIL    DB 'Failed to write sector.', 13, 10, 0
;     CHECKSUMINVALID    DB 'Invalid checksum for System16. SysLock.',13,10,0
     QBOOT_MSG          DB 'Restarting...',13,10,13,10,0
     QBOOT_ERROR        DB 'Couldn''t retrieve bootsector from fd0',13,10
                        DB 'Insert a bootable disk and hit a key...',13,10,0
     VIRTUALPC_MSG      DB '*** Virtual PC support enabled ***', 13, 10, 0
;                        DB 'V2_OS has detected that it''s running', 13, 10
;                        DB 'on a ''VirtualPC'', and is enabling', 13, 10
;                        DB 'support for it. This may cause some', 13, 10
;                        DB 'performance decrease. If you are NOT', 13, 10
;                        DB 'running on a ''VirtualPC'', please ', 13, 10
;                        DB 'contact the V2_Lab. lab@v2.nl', 13, 10
;                        DB '------------------------------------', 13, 10,0
     ;  ------------------------------------------------------------------------
     ; | ERROR MESSAGES
     ;  ------------------------------------------------------------------------
     DISKCHECKFAILED1   DB 'ERROR: Failed to retrieve info on the bootdisk...[1]', 13, 10, 0
     DISKCHECKFAILED2   DB 'ERROR: Failed to retrieve info on the bootdisk...[2]', 13, 10, 0
     DISKCHECKFAILED3   DB 'ERROR: Failed to retrieve info on the bootdisk...[3]', 13, 10, 0
     DISKCHECKFAILED4   DB 'ERROR: Failed to retrieve info on the bootdisk...[4]', 13, 10, 0
     INVALID_CPU        DB 'ERROR: This CPU cannot run 32Bit Code.', 13, 10, 0
     BOOTSECTORREADFAIL DB 'ERROR: Failed to retrieve bootsector data.', 13, 10, 0
     SYSTEM32READFAIL   DB 'ERROR: Failed to read System32 Code to memory.', 13, 10, 0
     ERRORLINE1         DB 'An error has occured that prevents the V2-OS from running.', 13, 10
     ;ERRORLINE2         DB '       Please fix this problem and restart V2-OS', 13, 10, 0
     ;ERRORLINE3         DB '       Call V2-Lab if you need Technical Help.', 13, 10, 0
     ERRORLINE4         DB '       System Halted.', 13, 10, 0
     ;  ------------------------------------------------------------------------
     ; | Global Descriptor Table (Used at bootup only)_
     ;  ------------------------------------------------------------------------
     MYGDT      DQ	0		 ;*** null descriptor ***

;     gdtcd	dw	-1,0,9A00h,0	 ; 64kB code segment, base to be set
;        	dw	-1,0,9200h,008Fh ; 4GB R/W segment, base=0
;	        dw	-1,0,9200h,0	 ; 64kB R/W segment, base=0

     gdtcd:
     System16_gdt:              ;*** 64kB code segment, base to be set ***
              	dw 0ffffh       ; Limit bits 15:00
                dw 0            ; Base bits 15:00
                db 00h          ; Base bits 23:16
                db 10011010b    ; Code, execute, read
                                ; Present, DPL 0, Non Sys Segment (9h)
                db 00000000b    ; Segment Limit 19:16 (0fh)
                                ; 1bte granularity, 16bit, avl = 0 (0Ch)
                db 0            ; Segment Base 32:24

     System32_gdt:              ;*** 64kB code segment, base to be set ***
              	dw 0ffffh       ; Limit bits 15:00
                dw 0            ; Base bits 15:00
                db 00h          ; Base bits 23:16
                db 10011010b    ; Code, execute, read
                                ; Present, DPL 0, Non Sys Segment (9h)
                db 11001111b    ; Segment Limit 19:16 (0fh)
                                ; 1bte granularity, 32bit, avl = 0 (0Ch)
                db 0            ; Segment Base 32:24



     Big_gdt:                   ;*** 4GB R/W segment, base=0 ***
              	dw 0ffffh       ; Limit bits 15:00
                dw 0            ; Base bits 15:00
                db 00h          ; Base bits 23:16
                db 10010010b    ; Code, execute, read
                                ; Present, DPL 0, Non Sys Segment (9h)
                db 11001111b    ; Segment Limit 19:16 (0fh)
                                ; 1bte granularity, 32bit, avl = 0 (0Ch)
                db 0            ; Segment Base 32:24

     System16Data:              ;*** The Writable Clone of System16Code ***
              	dw 0ffffh       ; Limit bits 15:00
                dw 0            ; Base bits 15:00
                db 00h          ; Base bits 23:16
                db 10010010b    ; Code, execute, read
                                ; Present, DPL 0, Non Sys Segment (9h)
                db 0            ; Segment Limit 19:16 (0fh)
                                ; 1bte granularity, 32bit, avl = 0 (0Ch)
                db 0            ; Segment Base 32:24

     System32Data:              ;*** The Writable Clone of System32Code ***
              	dw 0ffffh       ; Limit bits 15:00
                dw 0            ; Base bits 15:00
                db 00h          ; Base bits 23:16
                db 10010010b    ; Data, read/write
                                ; Present, DPL 0, Non Sys Segment (9h)
                db 11001111b    ; Segment Limit 19:16 (0fh)
                                ; 1bte granularity, 32bit, avl = 0 (0Ch)
                db 0            ; Segment Base 32:24

                dw	-1,0,9200h,008Fh ; 4GB R/W segment, base=0
                dw	-1,0,9200h,008Fh ; 4GB R/W segment, base=0

              ;  dw	-1,0,9200h,008Fh ; 4GB R/W segment, base=0
	      ;  dw	-1,0,9200h,0	 ; 64kB R/W segment, base=0

        SYSTEM16FUNC       DW SYS16FUNC00
                           DW SYS16FUNC01
                           DW SYS16FUNC02
                           DW SYS16FUNC03
                           DW SYS16FUNC04
                           DW SYS16FUNC05

        RMIDTLIMIT         DW 3FFH   ; REAL MODE IDT LIMIT
        RMIDTBASE          DD 0      ; REAL MODE IDT BASE
        PMIDTSAVE          DW 3FFH
                           DD 0
        DISKINFOBLOCK      DB 08 * 32 DUP (?)    ; 8 ENTRIES OF 32 BYTES
        PARTLIST           DB 16 * 32 DUP (?)   ; 16 ENTRIES OF 32 BYTES

        BS_HEAD     DB 0
        BS_SECTOR   DB 0
        BS_CYLINDER DB 0
        SINGLE_DOT  DB '.',0
        SINGLE_STAR DB '*',0
        SINGLE_BANG DB '!',0

INCLUDE V2OSFONT.ASM
;
; IN AL = COL
;    BL = RED
;    BH = GREEN
;    CL = BLUE
;
PALETTE:
  PUSH DX
      MOV DX, 3C8H
      OUT DX, AL
      INC DX

      MOV AL, BL
      OUT DX, AL

      MOV AL, BH
      OUT DX, AL

      MOV AL, CL
      OUT DX, AL
  POP DX
RET
;
SETV2PALETTE:
   MOV AX, 1003H
   MOV BL, 0
   INT 10H

   MOV AH, 10h
   MOV AL, 01h
   MOV BH, 1
   INT 10H         ; SET BORDERCOLOR TO 1

   MOV AL, 1
   MOV BX, 0
   MOV CX, 0
   CALL PALETTE     ; BORDERCLR

   MOV AL, 0
   MOV BX, 0
   MOV CL, 16
   CALL PALETTE     ; BACK CLR

   MOV AL, 2
   MOV BL, 63
   MOV BH, 63
   MOV CL, 43
   CALL PALETTE     ; EDIT TEXT

   MOV AL, 3
   MOV BL, 40
   MOV BH, 50
   MOV CL, 63
   CALL PALETTE     ; LO TEXT

   MOV AL, 7
   MOV BL, 40
   MOV BH, 50
   MOV CL, 63
   CALL PALETTE     ; SAME

   MOV AL, 4
   MOV BL, 63
   MOV BH, 63
   MOV CL, 63
   CALL PALETTE     ; HI TEXT

   MOV AL, 5
   MOV BL, 32
   MOV BH, 0
   MOV CL, 0
   CALL PALETTE     ; ERROR TEXT

   MOV AL, 56
   MOV BL, 16
   MOV BH, 16
   MOV CL, 32
   CALL PALETTE     ; TOPBAR      ; 8 !


   MOV AL, 58
   MOV BL, 00
   MOV BH, 10
   MOV CL, 00
   CALL PALETTE     ; DARKENED-GREY  (0Ah !

   MOV AL, 59
   MOV BL, 00
   MOV BH, 40
   MOV CL, 00
   CALL PALETTE     ; LIGHTER-GREY  (0Bh !

   MOV AL, 60
   MOV BL, 24
   MOV BH, 24
   MOV CL, 48
   CALL PALETTE     ; DARK-TOPBAR   (0ch !

RET
;
REPROGRAMFONT:
   PUSHAD
   PUSH ES
       MOV AX, DS
       MOV ES, AX
       MOV BP, OFFSET V2OSFONT
       MOV CX, 000FFH
       MOV DX, 0
       MOV BL, 0
       MOV BH, 8
       MOV AL, 0
       MOV AH, 11H
       INT 10H                               ; REPROGRAM FONT
   POP ES
   POPAD
RET

;
; This is where System16 takes control from the bootsector.
;
BEGIN:
   CLI
   MOV AX, CS  ; DS=SS='CS'
   MOV SS, AX
   MOV DS, AX
   MOV SP, OFFSET TMPSTACK
   ADD SP, 512
   MOV BOOTDISK, DL

   MOV BS_HEAD, DH
   MOV BS_CYLINDER, CL
   MOV BS_SECTOR, CH

   ;*** SET FANCY SCREENMODE ***

   MOV AX, 1112H
   MOV BL, 0
   INT 10H

   CALL SETV2PALETTE
   CALL REPROGRAMFONT


   MOV AH, 3
   MOV BH, 0
   INT 10H
   OR CH, 20H
   MOV AH, 1
   INT 10H                ; HIDE CURSOR..

   PUSH ES
    MOV AX, 0F000H
    MOV ES, AX

    MOV AL, ES:[110H]
    CMP AL, 'S'
    JNE NOTAMAC
    MOV AL, ES:[111H]
    CMP AL, 'h'
    JNE NOTAMAC
    MOV AL, ES:[112H]
    CMP AL, 'a'
    JNE NOTAMAC
    MOV AL, ES:[113H]
    CMP AL, 'm'
    JNE NOTAMAC
    MOV AL, ES:[114H]
    CMP AL, 'a'
    JNE NOTAMAC
    MOV AL, ES:[115H]
    CMP AL, 'h'
    JNE NOTAMAC

      MOV AL, 1
      MOV PCEMULATOR, AL
      MOV DL, 7
      MOV DI, OFFSET VIRTUALPC_MSG  ; DETECTED THE VIRTUALPC
      CALL WRITELN

NOTAMAC:


   POP ES

   MOV DL, 7
   MOV DI, OFFSET TRANSFEROK  ; REPORT THAT THIS CODE IS IN CONTROL.
   CALL WRITELN
 JMP SYSTEM16INITIALIZE
; STUFF DB 14096 DUP (?)
;----------------------------------------------------------------------------
DISPWORD:
      PUSH CX
      PUSH AX
      PUSH ES
      PUSH BX
          SHL DI, 1
          MOV BX, 0B800H
          MOV ES, BX
          ADD DI, 6
          MOV CX, 4
DISPWORDLOOP:
          MOV BX, AX
          AND BX, 00001111B
          MOV BL, DS:[OFFSET HEXTAB+BX]
          MOV ES:[DI], BL
          MOV BL, 1FH
          MOV ES:[DI+1], BL
          SHR AX, 4
          SUB DI, 2
         LOOP DISPWORDLOOP
      POP BX
      POP ES
      POP AX
      POP CX
     RET
;
; Waits for a Keypress
;
WAITKEY:
     PUSHF
     PUSHA
        MOV AH,1
        INT 16H
      JZ WAITKEY
        MOV AH,0
        INT 16H
     POPA
     POPF
  RET
;
; Uses the BIOS to say 'BEEEEP !'
;
BEEP:
  PUSH AX
    MOV AH, 0EH
    MOV AL, 07
    MOV BX, 0
    INT 10H
  POP AX
 RET
;
; Pass DS:DI as a pointer to a zero-terminated textline.
;
WRITEMSG:
       PUSHA
       PUSH ES
         MOV AX, 0B800H
         MOV ES, AX
      NEXTLETTER:
         MOV AL, DS:[DI]
         CMP AL, 0
         JE OUTWRITELOOP
          MOV ES:[SI], AL
          MOV AL, DL
          INC SI
          MOV ES:[SI], AL
          INC SI
          INC DI
          JMP NEXTLETTER
       OUTWRITELOOP:
      POP ES
      POPA
  RET
;----------------------------------------------------------------------------
WRITELN:
  PUSHF
  PUSHA

   MOV AH, 03H
   MOV BH, 0
   INT 10H      ; READ CURSORPOS  IN (Y=DH, X=DL)

      NEXTLETTER2:
         MOV AL, DS:[DI]
         CMP AL, 0
         JE OUTWRITELOOP2
          MOV AH, 0EH
          MOV BH, 0
          MOV BL, 5H
          INT 10H
          INC DI
          JMP NEXTLETTER2
       OUTWRITELOOP2:

  POPA
  POPF
  RET

;
; Pass DS:DI as a pointer to a zero-terminated textline.
; This will shift up the screen by 1 row and print the textline
;
WRITELNX:
   PUSHA
     PUSH ES
     MOV AX, 0B800H
     MOV ES, AX
     MOV SI, 80 * 2
     MOV DI, (80 * 2) * 2
     MOV CX, (80 * 2) * 24
    SHIFTUP:
        MOV AL, ES:[DI]
        MOV ES:[SI], AL
        INC SI
        INC DI
      LOOP SHIFTUP
     POP ES
   POPA
   MOV SI, (80 * 2) * 24
   CALL WRITEMSG
  RET
;
; Politely tell the user their system sucks...
;
EXIT_ERROR:
    MOV DL, 4
    PUSH DI
    MOV DL, (4 SHL 4) + 0FH
    MOV DI, OFFSET ERRORLINE1
    CALL WRITELN
    MOV DL, 0FH
    POP DI
    CALL WRITELN ; ERROR MESSAGE

;    MOV DI, OFFSET ERRORLINE2
;    CALL WRITELN
;    MOV DI, OFFSET ERRORLINE3
;    CALL WRITELN
;    MOV DI, OFFSET ERRORLINE4
;    CALL WRITELN
  JMP $
;
; Verify CPU capabilities
;
DETECT_PROCESSOR:                        
        PUSHF
        XOR AH, AH
        PUSH AX
        POPF
        PUSHF
        POP AX
        AND AH, 0F0H
        CMP AH, 0F0H
        JE SHORT DETECTNO386
        MOV AH, 0F0H
        PUSH AX
        POPF
        PUSHF
        POP AX
        AND AH, 0F0H
        JZ SHORT DETECTNO386
        POPF
        RET
DETECTNO386:
        MOV DI, OFFSET INVALID_CPU
        JMP EXIT_ERROR
;
; Enables the A20 Gate to access the memory over 1MB
;
ENABLEA20:                              ; ENABLE THE A20 GATE
        CALL ENABLEA20O1
        JNZ SHORT ENABLEA20DONE
        MOV AL, 0D1H
        OUT 64H, AL
        CALL ENABLEA20O1
        JNZ SHORT ENABLEA20DONE
        MOV AL, 0DFH
        OUT 60H, AL
       ENABLEA20O1:
        MOV ECX, 20000H
       ENABLEA20O1L:
        JMP SHORT $+2
        IN AL, 64H
        TEST AL, 2
        LOOPNZ ENABLEA20O1L
       ENABLEA20DONE:
  RET
;
; Jump from RealMode to ProtectedMode
;
RM2PM:
        ; IDT SOMEWHERE ?!?

	MOV EAX, CR0
	OR AL, 1
	MOV CR0, EAX		; System is now in 'Unreal-Mode'

        ;*** Make the major leap out of the Real-mode ***
	DB 0EAH   		; far jump to set CS & clear prefetch queue
        RM2PM_OFFSET DW 0
        RM2PM_DESC DW 0
; The End
;
INIT_PCIBUS:
    MOV PCIOK, 0
    MOV PCI_HIBUS, 0
    MOV AX, 0B101H
    INT 1AH
    JC EXIT_PCIBUS

    CMP DX, 04350H
    JNE EXIT_PCIBUS

    MOV PCICHAR, AL
    INC CL
    MOV PCI_HIBUS, CL
    MOV PCIVERLO, BL
    MOV PCIVERHI, BH
    MOV PCIOK, 1
  EXIT_PCIBUS:
  MOV DI, OFFSET PCIBUSSESNUMBER
  MOV AL, PCI_HIBUS
  ADD AL, '0'
  MOV DS:[DI], AL
  MOV DI, OFFSET PCIBUSSESFOUND
  MOV DL, 7
  CALL WRITELN

RET
;
SYSTEM16INITIALIZE:

   PUSHAD

      MOV AH, 8H             ; GET INFO
      MOV DL, 80H            ; ON HARDDISKS
      INT 13H
      JNC DISKCHECK2OK
        MOV DL, 7
        MOV DI, OFFSET DISKCHECKFAILED1
        CALL WRITELN
        XOR DL, DL
        ;JMP $
      DISKCHECK2OK:


      MOVZX DX, DL
      MOV NUMBEROFDRIVES, DX

      ;--------
      MOV AH, 8H             ; GET INFO
      MOV DL, BOOTDISK
      INT 13H
      JNC DISKCHECKOK
        MOV DL, 7
        MOV DI, OFFSET DISKCHECKFAILED2
        CALL WRITELN
        JMP $
      DISKCHECKOK:

      MOV BOOTDISK_HEADS, DH

      MOVZX DX, DL
      MOV NUMBEROFFLOPPIES, DX

      MOV AL, CL
      AND AL, 1FH    ; KEEP THE LOWER 5 BITS
      MOV BOOTDISK_SECTORS, AL

      SHR CL, 5
      MOV AH, CL
      MOV AL, CH
      MOV BOOTDISK_CYLINDERS, AX

   MOV DL, 7
   MOV DI, OFFSET CREATEPARTLIST
   CALL WRITELN

   MOV AH, 3
   MOV AL, 5
   XOR BX, BX
   INT 16H


   MOV DI, OFFSET PARTLIST
   MOV AL, 'f'
   MOV DS:[DI+0], AL
   MOV DS:[DI+16], AL
   MOV AL, 'd'
   MOV DS:[DI+1], AL
   MOV DS:[DI+17], AL
   MOV AL, '0'
   MOV DS:[DI+2], AL
   MOV DS:[DI+18], AL
   MOV AL, 0
   MOV DS:[DI+3], AL         ; 'FD0',0
   MOV DS:[DI+19], AL
   MOV AL, 0
   MOV DS:[DI+6], AL         ; DISK 0
   MOV EAX, 0
   MOV DS:[DI+7], EAX        ; SECTOR 0
   MOV EAX, 11223344H
   MOV DS:[DI+0BH], EAX      ; SECTORAMOUNT

   ADD DI, 32
   ;*** ADD THE DRIVES AND THEIR PARTITIONS
   MOV AX, NUMBEROFDRIVES
   CMP AX, 0
   JE DISKPARTITIONSDONE

   MOVZX ECX, AX             ; ECX IS THE AMOUNT OF PHYSICAL DISKS
  ;***********
  DISKLOOP:
    PUSH ECX
      ;*** READ THE -MASTER- BOOTSECTOR ***
      PUSH ECX
        MOV BX, 2050H    ; DISK BUFFER AREA
        MOV ES, BX       ; SEG BUFFER
        XOR BX, BX       ; OFS BUFFER
        MOV AH, 02H      ; FUNCT 2 (READ)
        MOV AL, 1        ; 1 SECTOR

        MOV DX, NUMBEROFDRIVES
        SUB DX, CX
        ADD DL, 80H      ; DRIVE
        MOV DH, 0        ; HEAD

        ;MOV DL, 80H      ; -UN-FIX THIS !!!

        MOV CH, 0        ; CYL
        MOV CL, 1        ; SECT

        INT 13H          ; READ SECTOR

      POP ECX
        MOV DX, NUMBEROFDRIVES
        SUB DX, CX
        ADD DL, 80H      ; DRIVE
        MOV DH, DL       ; SAVE DISKNR

      ;--- ADD PHYSICAL DISK TOO ---
        MOV AL, 'h'
        MOV DS:[DI+0], AL
        MOV DS:[DI+16], AL
        MOV AL, 'd'
        MOV DS:[DI+1], AL
        MOV DS:[DI+17], AL
        MOV AL, 'a'
        ADD AL, DH
        SUB AL, 80H
        MOV DS:[DI+2], AL
        MOV DS:[DI+18], AL
        MOV AL, 0
        MOV DS:[DI+3], AL       ; TERMINATE TEXT
        MOV DS:[DI+19], AL

        MOV AL, DH
        MOV DS:[DI+6], AL       ; DISKNR


        MOV EAX, 0              ; START SECTOR
        MOV DS:[DI+7], EAX
        MOV EAX, ES:[SI+0CH]    ; AMOUNT OF SECTORS
        MOV EAX, 011223344H     ; NEED TO FIX THIS   :)
        MOV DS:[DI+0BH], EAX
        ADD DI, 32

      ;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

      MOV SI, 1BEH
      MOV ECX, 4
      PARTITIONDUMPLOOP:
        MOV AL,ES:[SI+4]
        CMP AL, 0
        JE SKIPTHISPARTITIONENTRY
        MOV AL, 'h'
        MOV DS:[DI+0], AL
        MOV DS:[DI+16], AL

        MOV AL, 'd'
        MOV DS:[DI+1], AL
        MOV DS:[DI+17], AL

        MOV AL, 'a'
        ADD AL, DH
        SUB AL, 80H
        MOV DS:[DI+2], AL
        MOV DS:[DI+18], AL
        XOR AL, AL
        MOV DS:[DI+19], AL      ; TERMINATE DISK...

        MOV AL, 4
        SUB AL, CL
        ADD AL, '1'
        MOV DS:[DI+3], AL       ; PART NUMBER
        MOV AL, 0
        MOV DS:[DI+4], AL       ; TERMINATE TEXT
        MOV AL, DH
        MOV DS:[DI+6], AL       ; DISKNR
        MOV EAX, 0
        MOV DS:[DI+7], EAX      ; SECTOR 0

        MOV EAX, ES:[SI+8]      ; START SECTOR
        MOV DS:[DI+7], EAX
        MOV EAX, ES:[SI+0CH]    ; AMOUNT OF SECTORS
        MOV DS:[DI+0BH], EAX
        ADD DI, 32
        SKIPTHISPARTITIONENTRY:
        ADD SI, 10H
        DEC ECX
        CMP ECX, 0
      JNE PARTITIONDUMPLOOP
    POP ECX
    DEC ECX
    CMP ECX, 0
    JNE DISKLOOP
    MOV AL, 0FFH
    MOV DS:[DI], AL     ; TERMINATE THE LIST
    POPAD
   DISKPARTITIONSDONE:
 ;**********
   MOV AH, 8H          ; GET INFO
   MOV DL, 0           ; FLOPPY A:
   INT 13H
   JNC DISKCHECK1OK
     MOV DL, 7
     MOV DI, OFFSET DISKCHECKFAILED3
     CALL WRITELN
     JMP $
   DISKCHECK1OK:

   MOV SI, OFFSET DISKINFOBLOCK
   MOV AL, 0
   MOV DS:[SI+0], AL      ; DRIVE NUMBER
   MOV DS:[SI+6], AL      ; DISKINDEX

   MOV DS:[SI+1], BL      ; DRIVE TYPE
   MOV AH, CL
   SHR AH, 6              ; KEEP HI 2 BITS
   MOV AL, CH
   MOV DS:[SI+2], AX      ; CYLINDERS 
   MOV DS:[SI+4], DH      ; HEADS
   AND CL, 1FH            ; KEEP LOWER 5 BITS
   MOV DS:[SI+5], CL      ; SECTORS
   XOR AL, AL
   MOV DS:[SI+7], AL      ; RESERVED
   MOV EAX, 534F4942H
   MOV DS:[SI+8], EAX     ; 'BIOS'
   MOV EAX, 20202020H
   MOV DS:[SI+12], EAX    ; 000000
   XOR EAX, EAX
   MOV DS:[SI+16], EAX    ; SERVING MODULE
   XOR EAX, EAX
   MOV DS:[SI+20], EAX    ; SERVING MODULE

   MOV AL, 'f'
   MOV DS:[SI+24], AL
   MOV AL, 'd'
   MOV DS:[SI+25], AL
   MOV AL, '0'
   ADD AL, DS:[SI+0]
   MOV DS:[SI+26], AL
   XOR AL, AL
   MOV DS:[SI+27], AL    ; FD0, 1, 2 ETC...




   ADD SI, 32

   MOV AH, 8H          ; GET INFO
   MOV DL, 80H
   INT 13H
   CMP DL, 0
   JE FIXEDDISKINFOSCANDONE
   MOVZX ECX, DL
   MOV DX, 80H         ; FIXED DISK


   FIXEDDISKINFOSCAN:
    PUSH DX
    PUSH ECX
     PUSH DX
     MOV AH, 8H          ; GET INFO
     INT 13H
     JNC DISKCHECK3OK
       MOV DL, 7
       MOV DI, OFFSET DISKCHECKFAILED4
       CALL WRITELN
       JMP $
     DISKCHECK3OK:
     MOV AL, 0
     MOV DS:[SI+1], BL      ; DRIVE TYPE
     MOV AH, CL
     SHR AH, 6              ; KEEP HI 2 BITS
     MOV AL, CH
     MOV DS:[SI+2], AX      ; CYLINDERS
     MOV DS:[SI+4], DH      ; HEADS
     AND CL, 3FH            ; KEEP LOWER 6 BITS
     MOV DS:[SI+5], CL      ; SECTORS
     XOR AL, AL
     MOV DS:[SI+7], AL      ; RESERVED
     MOV EAX, 534F4942H
     MOV DS:[SI+8], EAX     ; 'BIOS'
     MOV EAX, 20202020H
     MOV DS:[SI+12], EAX    ; '    '
     XOR EAX, EAX
     MOV DS:[SI+16], EAX    ; SERVING MODULE
     XOR EAX, EAX
     MOV DS:[SI+20], EAX    ; SERVING MODULE
     POP DX
     MOV AL, 'h'
     MOV DS:[SI+24], AL
     MOV AL, 'd'
     MOV DS:[SI+25], AL
     MOV AL, 'a'
     ADD AL, DL
     SUB AL, 80H
     MOV DS:[SI+26], AL
     XOR AL, AL
     MOV DS:[SI+27], AL    ; HDA, B, C ETC...



     MOV DS:[SI+0], DL      ; DISKID
     MOV DS:[SI+6], DL      ; DISKINDEX
     ADD SI, 32
    POP ECX
    POP DX
    INC DX
   LOOP FIXEDDISKINFOSCAN
 FIXEDDISKINFOSCANDONE:
   MOV AL, 0FFH           ; END OF CHAIN
   MOV DS:[SI], AL

   MOV DL, 7
   MOV DI, OFFSET RETRIEVEBOOTSECT
   CALL WRITELN

   MOV AH, 2        ; READING SECTOR
   MOV AL, 1        ; JUST ONE
   MOV BX, 2050H    ; DISK BUFFER AREA
   MOV ES, BX       ; SEG BUFFER
   XOR BX, BX       ; OFS BUFFER
   MOV DL, BOOTDISK ; 'READ FROM' DISK
   MOV DH, BS_HEAD
   MOV CH, BS_CYLINDER
   MOV CL, BS_SECTOR
   INT 13H
   JNC BOOTSECTORREADOK
     MOV DI, OFFSET BOOTSECTORREADFAIL
     JMP EXIT_ERROR
   BOOTSECTORREADOK:

   MOV AL, ES:[40]
   MOV SYSTEM16SECTORS, AL
   MOV AL, ES:[41]
   INC AL
   MOV SYSTEM32SECTORS, AL

   MOV DL, 7
   MOV DI, OFFSET READSYSTEM32MSG
   CALL WRITELN
   ; CALCULATE THE LOCATION OF MEMORYSPACE FOR SYSTEM32
   XOR EAX, EAX

   MOV AL, SYSTEM16SECTORS
   INC AL
   SHL EAX, 9  ;*** MULTIPLY BY 512
   ADD EAX, 400H + 100H    ;(BASE OF SYSTEM16 + ORG100H)

   ADD EAX, 512   ; TEMP !??!
   shr eax, 4
   shl eax, 4
   MOV SYSTEM32ADDR, EAX

   MOV AH, 0
   INT 13H                ; RESET FLOPPY

   MOV EBX, SYSTEM32ADDR
   SHR EBX, 4              ; TO GET A SEGMENT IN BX
   MOV ES, BX              ; SET TO SEG

   MOV AL, 1               ; SYSTEM32SECTORS
   MOV BX, 100H            ; OFS 100H
   MOV DH, BS_HEAD               ; HEAD
   MOV CL, BS_SECTOR
   INC CL  ; SKIP BS
   ADD CL, SYSTEM16SECTORS

   MOV CH, BS_CYLINDER               ; TRACK
   MOV READ_CYL, CH
   MOV SI, CX
   DEC SI
   MOV CL, SYSTEM32SECTORS

   MOVZX ECX, CL
   ADD ECX, 5            ; AMOUNT OF SECTORS TO READ

  READSYSTEM32TOMEMORY:
   PUSH ECX
   PUSH EAX
       INC SI
       NEXTTRIMLOOP:
       MOV AX, SI
       CMP AL, BOOTDISK_SECTORS
       CMP AL, 12H
       JBE NOTNEXTSECTORBUNCH
         SUB AX, 12H
         MOV SI, AX
         INC DH
         CMP DH, 1
         JBE NOTNEXTCYL
           MOV DH, READ_CYL
           INC DH
           MOV READ_CYL, DH
           MOV DH, 0
         NOTNEXTCYL:
         JMP NEXTTRIMLOOP
       NOTNEXTSECTORBUNCH:
       MOV SI, AX

     MOV AL, 1               ; JUST 1 SECTOR AT A TIME
     MOV AH, 2               ; READING SECTOR
     MOV DL, BOOTDISK        ; DRIVE A:
    ; MOV DH, 0              ; HEAD
     MOV CX, SI              ; RESTORE CL
     MOV CH, READ_CYL        ; CYLINDER

     INT 13H
     JNC SYSTEM32READOK

       MOV DI, OFFSET SYSTEM32READFAIL
       JMP EXIT_ERROR
     SYSTEM32READOK:
       PUSH BX
         MOV AH, 0EH
         MOV AL, '.'
         MOV BX, 0
       INT 10H
       POP BX
       POP EAX
       POP ECX
       ADD BX, 512
     LOOP READSYSTEM32TOMEMORY

   MOV DL, 7
   MOV DI, OFFSET CR_LF
   CALL WRITELN
   MOV DL, 7
   MOV DI, OFFSET RETRIEVECMOS
   CALL WRITELN

   MOV CX, 37H
   MOV DL, 0
   MOV SI, OFFSET CMOSDATABLOCK
   READCMOSLOOP:
     MOV AL, DL
     OUT 70H, AL
     IN AL, 71H
     MOV DS:[SI], AL
     INC DL
     INC SI
   LOOP READCMOSLOOP

   CALL DETECT_PROCESSOR   ; THIS STALLS ON AN INVALID PROCESSOR.
   MOV DL, 7
   MOV DI, OFFSET PROCESSOROK
   CALL WRITELN


   MOV AX, 0E801H
   INT 15H
   AND EBX, 0FFFFH
   SHL EBX, 6
   AND EAX, 0FFFFH
   ADD EBX, EAX

   MOV EXTMEM, EBX


   CALL INIT_PCIBUS

   MOV DL, 7
   MOV DI, OFFSET A20ENABLE
   CALL WRITELN

   CALL ENABLEA20

   MOV DL, 7
   MOV DI, OFFSET SWITCH2PMODE
   CALL WRITELN

   ;---- [ Prepare The System for the BIG-Bang ] ----
   ;*** Set up the descriptor for System16 Code ***
   MOV AX, CS
   MOVZX EAX, AX
   SHL EAX, 4
   MOV DWORD PTR System16_gdt[2], EAX   ; eax=base for code segment
   MOV BYTE PTR System16_gdt[5], 9Ah    ; set segment attribute
   MOV DWORD PTR System16Data[2], EAX   ; eax=base for code segment
   MOV BYTE PTR System16Data[5], 92h    ; set segment attribute

   ;*** Set up the descriptor for System32 Code ***

   MOV EAX, SYSTEM32ADDR
   MOV DWORD PTR System32_gdt[2], EAX   ; eax=base for code segment
   MOV BYTE PTR System32_gdt[5],9Ah     ; set segment attribute

   MOV DWORD PTR System32Data[2], EAX      ; eax=base for code segment
   MOV BYTE PTR System32Data[5],92H        ; set segment attribute

        ;*** Prepare the LGDT Instruction ***
        MOV DX, OFFSET MYGDT
        MOVZX EDX, DX
        MOV AX, CS
        MOVZX EAX, AX
        SHL EAX, 4
	ADD EAX, EDX	        ; eax=base for GDT
	PUSH EAX
        MOV BX, GDT_ENTRIES
        SHL BX, 3                    ; MULIPLY BY 8
	PUSH BX    ; 28H + 8
	MOVZX EAX, SP
	CLI
        ; *** Here it goes... ***
	LGDT FWORD PTR SS:[EAX]
	ADD SP, 6               ; Release the stack space used

        MOV RM2PM_OFFSET, OFFSET PM16
        MOV RM2PM_DESC, 8H
        JMP RM2PM                            ; BYE BYE REALMODE !
;
; This is the PM16 Label.
; From here the system is running in protected mode!!!
; This Code-Descriptor is ofcourse defined as 16Bit,
; But, a few lines ago, the System32 Code got loaded to memory,
; and a Descriptor has been build for it.
; So to run in full-raw-32Bit-protected mode, only one far jmp is required.
; But first the PM2RM Portal needs to be tested. That will jump to System32.
;
PM16:
        MOV DX, 16 + 8          ; load long segment descriptor from GDT into DS
	MOV DS, DX
        MOV DX, 20H
        MOV SS, DX
        MOV ESP, OFFSET TMPSTACK
        ADD ESP, 512

        MOV AX, 20H
        MOV FS, AX
        MOV ES, AX

        MOV FS:[REAL_EAX], EAX

       ;*** PASS CONTROL TO SYSTEM32 ***
	DB 0EAH   		; far jump to set CS & clear prefetch queue
        DW 100H
        DW 16

;
; This is the entry point of the System16Functions.
; It redirects control based on the value of AL (NOT EAX)
;
SYSTEM16FUNCTION:
;     PUSH AX
;       MOV AX, 0404H
;       MOV GS:[0B8000H+80+80], AX     ; SHOW THAT THE CODE IS IN CONTROL
;     POP AX
     MOV DX, 20H
     MOV DS, DX		; load 64kB segment descriptor from GDT into DS
     MOV ES, DX		; load 64kB segment descriptor from GDT into ES
     MOV SS, DX		; load 64kB segment descriptor from GDT into SS
     MOV EDX, EAX       ; SAVE EAX
     MOV EAX, CR0
     AND AL, 0FEH
     MOV CR0, EAX	; sets Real Mode

     DB 0EAH	        ; far jump to set CS & clear prefetch queue
     DW BACKAGAIN       ; Offset
     DW 50h             ; Descriptor

 BACKAGAIN:
     MOV AX, CS
     MOV DS, AX
     MOV ES, AX
     MOV FS, AX
     MOV GS, AX
     MOV SS, AX
     MOV SP, OFFSET TMPSTACK
     ADD SP, 512
     MOVZX ESP, SP
     ; *** JUMP TO THE CORRECT SYSTEM16FUNCTION ***
     PUSHF
     MOV EAX, EDX    ; RESTORE EAX
     MOVZX DI, AL
     SHL DI, 1
     ADD DI, OFFSET SYSTEM16FUNC
     JMP CS:[DI]
;
; SYS16FUNC00 - Null Function.
; IN: AL  = 00H
; DESC: DOES NOTHING, AND RETURNS
;
SYS16FUNC00:
   PUSH AX
   MOV AX, ES
   PUSH AX
   MOV AX, 0B800H
   MOV ES, AX
   MOV AX, 031FH
   MOV ES:[00], AX
   POP ES
   POP AX
   POP EDI
JMP SYSTEM16FUNCTIONEND
;
; SYS16FUNC01 - Realmode Interrupt
; IN: AL  = 01H
;     AH  = INTERRUPT NUMBER TO FIRE
; DESC: Perform a RealmodeInterrupt
;
SYS16FUNC01:
   POP EDI
   PUSHAD
     PUSH CS
     POP DS
       
     SIDT FWORD PTR CS:PMIDTSAVE
     LIDT FWORD PTR CS:RMIDTLIMIT    ; << EXPENSIVE LINE OF CODE HERE !!!

     MOV CS:RM_INT_TO_DO, AH

     MOV EAX, REAL_EAX
     MOV EBX, REAL_EBX
     MOV ECX, REAL_ECX
     MOV EDX, REAL_EDX
     MOV ESI, REAL_ESI
     MOV EDI, REAL_EDI
    ; MOV DS, REAL_DS
     MOV ES, REAL_ES
     MOV FS, REAL_FS

     DB 0CDH            ; INT INSTRUCTION
     RM_INT_TO_DO DB 0  ; INT PARAMETER
     MOV REAL_EAX, EAX
     MOV REAL_EBX, EBX
     MOV REAL_ECX, ECX
     MOV REAL_EDX, EDX
     MOV REAL_ESI, ESI
     MOV REAL_EDI, EDI
     MOV REAL_ES, ES

     LIDT FWORD PTR CS:PMIDTSAVE
   POPAD
JMP SYSTEM16FUNCTIONEND

;
; CONVERTS EAX TO CH, CL, DH
;
SECSINTRAK  DD 0
HEADSONDISK DW 0

TRIM:
       MOV DX, 0         ; KOP
       MOV CX,0          ; SECTOR & TRACK
       XOR ESI, ESI
       DEC EAX
REDOTRIM:
       CMP EAX, SECSINTRAK
       JB OKTRIMMEDENUFF
           SUB EAX, SECSINTRAK
           INC DX                  ; KOP + 1
           CMP DX, HEADSONDISK     ; HEADS AMOUNT
           JB REDOTRIM
              SUB DX, HEADSONDISK  ;
              INC CH               ; TRACK + 1
              INC ESI
         JMP REDOTRIM
OKTRIMMEDENUFF:
       MOVZX EDX, DX
       MOV FOUND_HEAD, EDX
       MOV DH, DL
       INC EAX
       MOV FOUND_SECTOR, EAX
       MOV FOUND_CYLINDER, ESI
       MOV EAX, FOUND_CYLINDER

       MOV CH, AL
       SHR EAX, 8
       SHL EAX, 6
       MOV EBX, FOUND_SECTOR
       ADD EAX, EBX
       MOV CL, AL               ; SECTOR (IN BITS 0..5)
                                ; HIPART OF CYL  (6..7)

      ; MOV CL, AL
      ; INC CL
   RET
;
INCREASEDISKSECTOR:
  PUSH EBX
      MOV EAX, FOUND_SECTOR
      INC EAX
      MOV FOUND_SECTOR, EAX     ; INCREASE A SECTOR

      MOV EBX, SECSINTRAK
      CMP EAX, EBX
      JBE SECSTILLOK
        SUB EAX, EBX       ; CORRECT IT
        INC EAX            ; PLUS 1
        MOV FOUND_SECTOR, EAX

        MOV EAX, FOUND_HEAD
        INC EAX
        MOV FOUND_HEAD, EAX
        XOR EBX, EBX
        MOV BX, HEADSONDISK
        CMP EAX, EBX
        JBE RHEADSTILLOK
          SUB EAX, EBX          ; CORRECT IT
          MOV FOUND_HEAD, EAX
          MOV EAX, FOUND_CYLINDER
          INC EAX
          MOV FOUND_CYLINDER, EAX

        RHEADSTILLOK:

      SECSTILLOK:
  POP EBX
RET
;
; SYS16FUNC02 - The Disk READ routine.
; IN: AL  = 02H
; DESC: Read 'ecx' sectors from disk 'dl', starting at sector 'ebx' to diskbuffer
;
SECTORSREAD DD 0
SYS16FUNC02_DISKNR DB 0
SYS16FUNC02:
   POP EDI
   PUSHAD
     PUSH CS
     POP DS


     SIDT FWORD PTR CS:PMIDTSAVE
     LIDT FWORD PTR CS:RMIDTLIMIT    ; << EXPENSIVE LINE OF CODE HERE !!!

     ;*** SET TRIMMING PARAMETERS ***
     MOV EDX, REAL_EDX
     MOV SYS16FUNC02_DISKNR, DL
     MOV SI, OFFSET DISKINFOBLOCK

     TRYNEXTDISKENTRY:
     MOV AL, DS:[SI]
     CMP AL, DL           ; COMPARE TO DISK
     JE FOUNDDISKENTRY
      ADD SI, 32
      CMP AL, 0FFH
      JNE TRYNEXTDISKENTRY
        JMP $
    FOUNDDISKENTRY:

     MOV AL, DS:[SI+5]
     MOVZX EAX, AL
   ;   MOV EAX, 62
     MOV SECSINTRAK, EAX
    
     MOV AL, DS:[SI+4]
     MOVZX AX, AL
     INC AX

     MOV HEADSONDISK, AX

     ;*** GET THE SECTOR-NUMBER TO READ ***
     MOV EBX, REAL_EBX
     INC EBX
     MOV REAL_EBX, EBX
     MOV EAX, EBX

     ;*** TRIM IT ***
     CALL TRIM

     ;*** EXECUTE COMMAND ***
     MOV EAX, REAL_ECX         ; SECTORS REQUESTED
     MOV EBX, 0FFFFH
     SHR EBX, 9
     ;SHR EBX, 2

     CMP EAX, EBX
     JB SECTORREQUESTOK
       MOV REAL_ECX, EBX       ; CORRECT IT
     SECTORREQUESTOK:
     XOR EAX, EAX
     MOV SECTORSREAD, EAX

     MOV BX, DISKBUFFERSEGMENT
     MOV ES, BX
     XOR BX, BX
  HEYANOTHERSECTORREAD:

      MOV EAX, REAL_EDX   ; DISK IN EAX
      MOV DL, AL          ; DL IS THE DISKNUMBER TO ACT ON
      MOV EDI, 0

     PUSHAD
       MOV DL, 7
       MOV DI, OFFSET SINGLE_DOT
      ; CALL WRITELN
     POPAD

   RETRYREAD:


     MOV AH, 02H         ; FUNCTION
     MOV AL, 1           ; ONE SECTOR
     INT 13H
     JNC NOREADERROR
       PUSHAD
         MOV DL, 7
         MOV DI, OFFSET SINGLE_BANG
        ; CALL WRITELN
       POPAD
       MOV AH, 0
       PUSH DX
       ;MOV AH, 0
       ;MOV DL, 80H
       INT 13H           ; RESET FDD
       ;MOV DL, 0

       POP DX

       INC EDI
       CMP EDI, 100
       JBE RETRYREAD
       MOV AX, BX
       MOV EDI, 80 *30
       CALL DISPWORD

       MOV DL, 7
       MOV DI, OFFSET SECTORREADFAIL
       CALL WRITELN

       MOV EAX, 13H
       JMP ALL_SECTORS_READ
   NOREADERROR:

      MOV EAX, SECTORSREAD
      INC EAX
      MOV SECTORSREAD, EAX

      MOV EAX, REAL_ECX   ; SECTORS LEFT TO READ
      DEC EAX
      CMP EAX, 0
      JE ALL_SECTORS_READ
      MOV REAL_ECX, EAX   ; DECREASE IT

      ;*** GET THE SECTOR-NUMBER TO READ ***
      PUSH BX       ; DISKBUFFEROFFSET

      MOV EBX, REAL_EBX
      INC EBX
      MOV REAL_EBX, EBX

      MOV EAX, EBX

      ;*** TRIM IT ***

      CALL TRIM
      POP BX
      ADD BX, 512
      JMP HEYANOTHERSECTORREAD

   ALL_SECTORS_READ:
     MOV REAL_EAX, EAX ; THE ERRORCODE
     MOV EAX, SECTORSREAD
     MOV REAL_ECX, EAX



     LIDT FWORD PTR CS:PMIDTSAVE     ; PREPARE TO RETURN AGAIN
     CMP SYS16FUNC02_DISKNR, 0
     JNE DONTDIMFLOPPYLIGHTS
       cli
       MOV DX, 3F2H
       MOV AL, 12
       OUT DX, AL
     DONTDIMFLOPPYLIGHTS:

   POPAD
JMP SYSTEM16FUNCTIONEND
;
; SYS16FUNC03 - The Disk WRITE routine.
; IN: AL  = 03H
; DESC: Write 'cx' sectors from disk 'dl', starting at sector 'ebx' to diskbuffer
;
SECTORSWRITEN DD 0
SYS16FUNC03:
   POP EDI
   PUSHAD
     PUSH CS
     POP DS

     SIDT FWORD PTR CS:PMIDTSAVE
     LIDT FWORD PTR CS:RMIDTLIMIT    ; << EXPENSIVE LINE OF CODE HERE !!!

     ;*** SET TRIMMING PARAMETERS ***
     MOV EDX, REAL_EDX
     MOV SI, OFFSET DISKINFOBLOCK

     TRYNEXTDISKENTRY2:
     MOV AL, DS:[SI]
     CMP AL, DL           ; COMPARE TO DISK
     JE FOUNDDISKENTRY2
      ADD SI, 32
      CMP AL, 0FFH
      JNE TRYNEXTDISKENTRY2
        JMP $
    FOUNDDISKENTRY2:

     MOV AL, DS:[SI+5]
     MOVZX EAX, AL
     MOV SECSINTRAK, EAX
    
     MOV AL, DS:[SI+4]
     MOVZX AX, AL
     INC AX

     MOV HEADSONDISK, AX

     ;*** GET THE SECTOR-NUMBER TO WRITE ***
     MOV EBX, REAL_EBX
     INC EBX
     MOV REAL_EBX, EBX
     MOV EAX, EBX

     ;*** TRIM IT ***

     CALL TRIM

     ;*** EXECUTE COMMAND ***

     MOV EAX, REAL_ECX         ; SECTORS REQUESTED
     MOV EBX, 0FFFFH
     SHR EBX, 9

     CMP EAX, EBX
     JB SECTORREQUESTOK2
       MOV REAL_ECX, EBX       ; CORRECT IT
     SECTORREQUESTOK2:
     XOR EAX, EAX
     MOV SECTORSWRITEN, EAX

     MOV BX, DISKBUFFERSEGMENT
     MOV ES, BX
     XOR BX, BX
  HEYANOTHERSECTORWRITE:

      MOV EAX, REAL_EDX   ; DISK IN EAX
      MOV DL, AL          ; DL IS THE DISKNUMBER TO ACT ON
      MOV EDI, 0

      PUSHAD
        MOV DL, 7
        MOV DI, OFFSET SINGLE_STAR
      ;  CALL WRITELN
      POPAD

    RETRYWRITE:
     MOV AH, 03H         ; FUNCTION
     MOV AL, 1           ; ONE SECTOR
     INT 13H
     JNC NOWRITEERROR
       INC EDI
       CMP EDI, 10
       JBE RETRYWRITE
       MOV DL, 7
       MOV DI, OFFSET SECTORWRITEFAIL
       CALL WRITELN
       MOV EAX, 14H
       JMP ALL_SECTORS_WRITEN
   NOWRITEERROR:

      MOV EAX, SECTORSWRITEN
      INC EAX
      MOV SECTORSWRITEN, EAX

      MOV EAX, REAL_ECX   ; SECTORS LEFT TO READ
      DEC EAX
      CMP EAX, 0
     JE ALL_SECTORS_WRITEN
      MOV REAL_ECX, EAX   ; DECREASE IT

      ;*** GET THE SECTOR-NUMBER TO READ ***
      PUSH BX       ; DISKBUFFEROFFSET

      MOV EBX, REAL_EBX
      INC EBX
      MOV REAL_EBX, EBX

      MOV EAX, EBX

      ;*** TRIM IT ***

      CALL TRIM
      POP BX
      ADD BX, 512
      JMP HEYANOTHERSECTORWRITE

   ALL_SECTORS_WRITEN:
     MOV REAL_EAX, EAX ; THE ERRORCODE

     MOV EAX, SECTORSWRITEN
     MOV REAL_ECX, EAX


     LIDT FWORD PTR CS:PMIDTSAVE     ; PREPARE TO RETURN AGAIN
   POPAD
JMP SYSTEM16FUNCTIONEND
;
; SYS16FUNC04 - QBoot
; IN: AL  = 04H
; DESC: Does a QuickReboot with the fd0: bootsector
;
QBOOT_VIDMODE DB 0
SYS16FUNC04:
   POP EDI
   PUSHAD
     PUSH CS
     POP DS
       
     SIDT FWORD PTR CS:PMIDTSAVE
     LIDT FWORD PTR CS:RMIDTLIMIT    ; << EXPENSIVE LINE OF CODE HERE !!!

     MOV AH, 0FH
     INT 10H
     MOV QBOOT_VIDMODE, AL
     CMP AL, 3
     JE VID_MODE_OK
       MOV AH, 0
       MOV AL, 03H
       INT 10H
     VID_MODE_OK:

     MOV AX, 0B800H
     PUSH ES
        MOV ES, AX
        XOR DI, DI
        XOR AL, AL
        MOV AH, 07H
        CLEARSCREENLOOP:
          MOV ES:[DI], AL
          MOV ES:[DI+1], AH
          INC DI
          INC DI
        LOOP CLEARSCREENLOOP
     POP ES

     MOV AH, 02
     MOV BH, 0
     MOV DH, 49
     MOV DL, 0
     INT 10H            ; SET CURSOR POS

     MOV EDI, 80*40
     XOR AH, AH
     MOV AL, QBOOT_VIDMODE
    ; CALL DISPWORD


     MOV DL, 7
     MOV DI, OFFSET QBOOT_MSG
     CALL WRITELN
    XOR SI, SI
    RETRYREBOOT:
     MOV AH, 0
     INT 13H


     MOV AX, 0500H
     MOV ES, AX
     MOV BX, 100H
     MOV AH, 2           ; READING SECTOR
     MOV AL, 1
     MOV DL, 0           ; DRIVE NR
     MOV DH, 0
     MOV CH, 0
     MOV CL, 1           ; SECTOR
     INT 13H

     JNC OKREBOOTNOW
        INC SI
        CMP SI, 5
       JB RETRYREBOOT
        XOR SI, SI
        MOV DL, 7
        MOV DI, OFFSET QBOOT_ERROR
        CALL WRITELN
      WAITKEY2:
        MOV AH,1
        INT 16H
      JZ WAITKEY2
        MOV AH,0
        INT 16H

      JMP RETRYREBOOT
    OKREBOOTNOW:

     XOR DX, DX    ; BOOTDISK

     DB 0EAH   		 ; Far jump
     DW 0100H            ; OFS
     DW 0500H            ; SEG

     LIDT FWORD PTR CS:PMIDTSAVE
   POPAD
JMP SYSTEM16FUNCTIONEND
;
; SYS16FUNC05 - Set V2_OS Cool Textmode
; IN: AL  = 05H
;
SYS16FUNC05:
   POP EDI
   PUSHAD
     PUSH CS
     POP DS
       
     SIDT FWORD PTR CS:PMIDTSAVE
     LIDT FWORD PTR CS:RMIDTLIMIT    ; << EXPENSIVE LINE OF CODE HERE !!!

     MOV AH, 0FH
     INT 10H
     CMP AL, 3
     JE VID_MODE_OK2
       MOV AH, 0
       MOV AL, 03H
       INT 10H
       ;*** SET FANCY SCREENMODE ***
       MOV AX, 1112H
       MOV BL, 0
       INT 10H
     VID_MODE_OK2:


     CALL SETV2PALETTE
     CALL REPROGRAMFONT

     MOV AH, 3
     MOV BH, 0
     INT 10H
     OR CH, 20H
     MOV AH, 1
     INT 10H                ; HIDE CURSOR..


     LIDT FWORD PTR CS:PMIDTSAVE
   POPAD
JMP SYSTEM16FUNCTIONEND
;
; This is the end of a System16Function.
; It returns back to protected mode.
;

SYSTEM16FUNCTIONEND:
  POPF
  MOV EAX, SYSTEM16FUNC_RETURN_ADDR
  MOV SYSTEM16FUNC_CALLER_OFS2, AX

  MOV AX, OFFSET PM16_X
  MOV RM2PM_OFFSET, AX
  MOV RM2PM_DESC, 8H
  CLI
  JMP RM2PM                             ; BYE BYE REALMODE !

PM16_X:
  MOV DX, 16 + 8          ; load long segment descriptor from GDT into DS
  MOV DS, DX
  MOV DX, 20H
  MOV SS, DX
  MOV ESP, OFFSET TMPSTACK
  ADD ESP, 512

  DB 0EAH   		; far jump to set CS & clear prefetch queue
  SYSTEM16FUNC_CALLER_OFS2 DW 0
  DW 10H
  FILLER DB 200H DUP (1)

END System16


