;=============================================================
; ShowSettings
;=============================================================
ShowSettings:
	push	eax
	push	ebx
	push	edi

	mov	al,4
	mov	edi,SBFound
	int	20h
	
	mov	al,4
	mov	edi,[SBModel]
	int	20h
	
	mov	al,4
	mov	edi,SBType
	int	20h
	
	mov	ax,0205h
	mov	bx,[SBPort]
	int	20h

	mov	al,4
	mov	edi,SBOnIRQ
	int	20h
	mov	ax,0105h
	mov	bl,[SBIRQ]
	int	20h
	
	mov	al,4
	mov	edi,SBOnLoDMA
	int	20h
	mov	ax,0105h
	mov	bl,[SBLoDMA]
	int	20h
	
	mov	al,4
	mov	edi,SBOnHiDMA
	int	20h
	mov	ax,0105h
	mov	bl,[SBHiDMA]
	int	20h
	
	mov	al,4
	mov	edi,SBDSPVer
	int	20h
	
	mov	bh,[DSPVMajor]
	mov	bl,[DSPVMinor]
	mov	ax,0205h
	int	20h

	mov	al,4
	mov	edi,CRLF
	int	20h
	
	mov	al,4
	mov	edi,CRLF
	int	20h

	pop	edi
	pop	ebx
	pop	eax
	ret

; vars

	SBModel1x	DB 'SoundBlaster 1.x',0
	SBModel20	DB 'SoundBlaster 2.0',0
	SBModelPro	DB 'SoundBlaster Pro',0
	SBModelPro2	DB 'SoundBlaster Pro II',0
	SBModelSB16	DB 'SoundBlaster 16',0
	SBModelSB162	DB 'SoundBlaster 16 SCSI-2',0
	SBModelAWE32	DB 'SoundBlaster AWE32',0
	SBModelAWE64	DB 'SoundBlaster AWE64',0
	SBUnkModel	DB 'Unknown Model (probably a SB16 compatible)',0	
	
	SBNotFound	DB 'SB not found.. :(',13,10,0
 	SBFound		DB 'I found a ',0
 	SBType		DB ' on',13,10,13,10
 	SbOnPort	DB 'P',0
	SBOnIRQ		DB ' I',0
	SBOnLoDMA	DB ' D',0
	SBOnHiDMA	DB ' H',0
	SBDSPVer	DB 13,10,'DSP Version : ',0