/* gccmodtest.c */

/*
 * 22/12/1999 Joost Faassen, Carlo Prelz
 * Copyright (C) V2_Lab Rotterdam
 *
 * Tests the services provided by module gccmod
 *
 * $Log: gccmodtest.c,v $
 * Revision 1.1  1999/12/23 10:16:56  karl
 * Initial revision
 *
 */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "v2os.h"

void main(void)
{
	int i;
	unsigned long ul1;
	unsigned short us1,*smodin;
	
/*
 * The gccmod module provides 3 services.
 * The third service requires an input value (a short).
 * Here I obtain the relative pointer
 *
 * You must know what pointer to expect. There is NO checking.
 * The first parameter must be a 8-character string EQUAL to that defined
 * in modID in the module source file.
 */

	smodin=service_input_data("V2 carlo",START_USER_SERVICES+2);

/*
 * Now call each service 5 times
 */

	for(i=0;i<5;i++)
	{
		
/*
 * The first service does not return anything
 */
		
		modservice("V2 carlo",START_USER_SERVICES);
	
/*
 * The second service returns an unsigned long
 */

		ul1=*((unsigned long *)modservice("V2 carlo",START_USER_SERVICES+1));
		puts("Service 2 returns ");
		hexprintl(ul1);
		puts("\r\n");
		
/*
 * The second service returns an unsigned short,
 * and receives an unsigned short as input
 */
		
		*smodin=i<<4; /* assign a value to the input value */
		us1=*(unsigned short *)modservice("V2 carlo",START_USER_SERVICES+2);
		puts("Service 3 returns ");
		hexprints(us1);
		puts("\r\n");
	}
}


