/* v2os_mod.h */

/*
 * 10/12/1999 Joost Faassen, Carlo Prelz
 * Copyright (C) V2_Lab Rotterdam
 *
 * Standard include file for developing *modules*
 * for V2_OS in C/Linux
 *
 * $Log: v2os_mod.h,v $
 * Revision 1.1  1999/12/23 10:15:17  karl
 * Initial revision
 *
 */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "v2os.h"

typedef void (*voidcall)(void);

typedef struct
{
	void *data;
	unsigned long datalen,abs_address;
} service_data_stc;
	
typedef struct
{
	service_data_stc in,out;
	voidcall call;
} service_stc;

extern voidcall service_calls[];
extern service_stc services[],lib_services[];
extern unsigned long n_local_services;

extern void announce(unsigned char *servtype);
extern unsigned long ret_from_service(int service,unsigned char lib_flg,void *data);
extern void fill_service_area(void);



